VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsApplicationSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Last update: 2002/04/27

Private Const ERRBASE As Long = -2147220334 'AS

Private mobjIniFile As New ClsInifile
Private mstrComplexityAxisDescription As String
Private mstrComplexityColumnHeading As String
Private mstrExitButtonCaption As String
Private mstrExitButtonTip As String
Private mstrFileNotFound As String
Private mstrFileSelectorCaption As String
Private mstrFileToLoad As String
Private mstrHelpButtonCaption As String
Private mstrHelpButtonTip As String
Private mstrHelpFile As String
Private mstrLinesAxisDescription As String
Private mstrLinesColumnHeading As String
Private mstrOpenButtonCaption As String
Private mstrOpenButtonTip As String
Private mstrParametersColumnHeading As String
Private mstrPointColumnHeading As String
Private mstrPreviousDirectory As String
Private mstrPrintButtonCaption As String
Private mstrPrintButtonTip As String
Private mstrProcedureColumnHeading As String
Private mstrProgramCaption As String
Private mstrProjectFileType As String
Private mysnIsAlreadyConstructed As Boolean
Private mysnRememberDirectory As Boolean
Private mstrComplexitySuffix As String
Private mstrLinesSuffix As String
Private mstrParameterSuffix As String
Private mstrWindowCaption As String

Private Sub Class_Initialize()
 setDefaults
End Sub

Private Sub Class_Terminate()
 Set mobjIniFile = Nothing
End Sub

Public Function complexityAxisDescription() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrComplexityAxisDescription = mobjIniFile.getValue("Report", "complexity axis description", mstrComplexityAxisDescription)
 End If
 complexityAxisDescription = mstrComplexityAxisDescription
End Function

Public Function complexityColumnHeading() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrComplexityColumnHeading = mobjIniFile.getValue("Report", "complexity column heading", mstrComplexityColumnHeading)
 End If
 complexityColumnHeading = mstrComplexityColumnHeading
End Function

Public Function complexitySuffix() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrComplexitySuffix = mobjIniFile.getValue("Spot popup", "complexity suffix", mstrComplexitySuffix)
 End If
 complexitySuffix = mstrComplexitySuffix
End Function

Public Sub construct(ByVal strCommandLine As String)
 If mysnIsAlreadyConstructed Then
   Err.Raise ERRBASE + 1, "ClsApplicationSettings.construct", "The construct method can only be used once."
 Else
   cutAndSetIniFileFromCommandLine strCommandLine
   strCommandLine = stripQuotes(strCommandLine)
   mstrFileToLoad = strCommandLine
   mysnIsAlreadyConstructed = True
 End If
End Sub

Private Sub cutAndSetIniFileFromCommandLine(ByRef strCmdLine As String)
 Dim strIniFile As String
 Dim intStartPos As Integer
 intStartPos = InStr(1, strCmdLine, "-ini")
 If intStartPos > 0 Then
   cutQuotedOptionFromPos strCmdLine, intStartPos, strIniFile
 Else
   strIniFile = App.Path & "\" & App.EXEName & ".ini"
 End If
 If Len(strIniFile) > 0 Then
   If Len(Dir$(strIniFile)) > 0 Then
     mobjIniFile.construct strIniFile, False
   End If
 End If
End Sub

Private Sub cutQuotedOptionFromPos(ByRef strCmdLine As String, ByVal intStartPos As Integer, ByRef strInto As String)
 Dim intPos As Integer
 Dim intEndPos As Integer
 intPos = InStr(intStartPos, strCmdLine, """", vbTextCompare)
 If intPos = 0 Then
   Err.Raise ERRBASE + 2, "ClsApplicationSettings.cutQuotedOptionFromPos", "Option must be quoted."
 Else
   intEndPos = InStr(intPos + 1, strCmdLine, """", vbTextCompare)
   If intEndPos = 0 Then intEndPos = Len(strCmdLine) + 1
   strInto = Trim$(Mid$(strCmdLine, intPos + 1, intEndPos - intPos - 1))
   strCmdLine = Left$(strCmdLine, intStartPos - 1) & Mid$(strCmdLine, intEndPos + 1)
 End If
End Sub

Public Function exitButtonCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrExitButtonCaption = mobjIniFile.getValue("Captions", "exit button", mstrExitButtonCaption)
 End If
 exitButtonCaption = mstrExitButtonCaption
End Function

Public Function exitButtonTip() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrExitButtonTip = mobjIniFile.getValue("Tooltips", "exit button", mstrExitButtonTip)
 End If
 exitButtonTip = mstrExitButtonTip
End Function

Public Function fileNotFoundMessage(ByVal strFile As String) As String
 Dim intPos As Integer
 If Not (mobjIniFile Is Nothing) Then
   mstrFileNotFound = mobjIniFile.getValue("Messages", "file not found", mstrFileNotFound)
 End If
 fileNotFoundMessage = mstrFileNotFound
 intPos = InStr(1, mstrFileNotFound, "%1%", vbTextCompare)
 If intPos > 0 Then
   fileNotFoundMessage = Left$(mstrFileNotFound, intPos - 1) & strFile & Mid$(mstrFileNotFound, intPos + 3)
 End If
End Function

Public Function fileSelectorCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrFileSelectorCaption = mobjIniFile.getValue("Captions", "file selector title", mstrFileSelectorCaption)
 End If
 fileSelectorCaption = mstrFileSelectorCaption
End Function

Public Function fileToStartUpWith() As String
 fileToStartUpWith = mstrFileToLoad
End Function

Public Function helpButtonCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrHelpButtonCaption = mobjIniFile.getValue("Captions", "help button", mstrHelpButtonCaption)
 End If
 helpButtonCaption = mstrHelpButtonCaption
End Function

Public Function helpButtonTip() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrHelpButtonTip = mobjIniFile.getValue("Tooltips", "help button", mstrHelpButtonTip)
 End If
 helpButtonTip = mstrHelpButtonTip
End Function

Public Function helpFile() As String
'Lazily computed
 Static ysnHasRunbefore As Boolean
 If Not ysnHasRunbefore Then
   If Not (mobjIniFile Is Nothing) Then
     mstrHelpFile = mobjIniFile.getValue("Files", "help", mstrHelpFile)
   End If
   If InStr(1, mstrHelpFile, "\", vbTextCompare) <= 0 Then
     mstrHelpFile = App.Path & "\" & mstrHelpFile
   End If
   If Len(mstrHelpFile) > 0 Then
     If Len(Dir$(mstrHelpFile)) = 0 Then mstrHelpFile = ""
   End If
   ysnHasRunbefore = True
 End If
 helpFile = mstrHelpFile
End Function

Public Function linesAxisDescription() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrLinesAxisDescription = mobjIniFile.getValue("Report", "lines axis description", mstrLinesAxisDescription)
 End If
 linesAxisDescription = mstrLinesAxisDescription
End Function

Public Function linesColumnHeading() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrLinesColumnHeading = mobjIniFile.getValue("Report", "lines column heading", mstrLinesColumnHeading)
 End If
 linesColumnHeading = mstrLinesColumnHeading
End Function

Public Function linesSuffix() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrLinesSuffix = mobjIniFile.getValue("Spot popup", "lines suffix", mstrLinesSuffix)
 End If
 linesSuffix = mstrLinesSuffix
End Function

Public Function openButtonCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrOpenButtonCaption = mobjIniFile.getValue("Captions", "open button", mstrOpenButtonCaption)
 End If
 openButtonCaption = mstrOpenButtonCaption
End Function

Public Function openButtonTip() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrOpenButtonTip = mobjIniFile.getValue("Tooltips", "open button", mstrOpenButtonTip)
 End If
 openButtonTip = mstrOpenButtonTip
End Function

Public Function openDirectory() As String
 If rememberDirectory Then
   If Len(mstrPreviousDirectory) = 0 Then mstrPreviousDirectory = pathOf(fileToStartUpWith)
   If Len(mstrPreviousDirectory) = 0 Then
     mstrPreviousDirectory = GetSetting("OHNO", "Settings", "directory", mobjIniFile.getValue("Settings", "start directory", App.Path & "\"))
   End If
   openDirectory = mstrPreviousDirectory
 Else
   openDirectory = pathOf(fileToStartUpWith)
 End If
End Function

Public Function parametersColumnHeading() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrParametersColumnHeading = mobjIniFile.getValue("Report", "parameters column heading", mstrParametersColumnHeading)
 End If
 parametersColumnHeading = mstrParametersColumnHeading
End Function

Public Function parameterSuffix() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrParameterSuffix = mobjIniFile.getValue("Spot popup", "parameter suffix", mstrParameterSuffix)
 End If
 parameterSuffix = mstrParameterSuffix
End Function

Private Function pathOf(ByVal strFullFileName As String) As String
 Dim intPos As Integer
 intPos = Len(strFullFileName)
 If intPos > 0 Then 'necessary to prevent error from Mid$ function
   While intPos > 0 And Mid$(strFullFileName, intPos, 1) <> "\"
        intPos = intPos - 1
   Wend
 End If
 strFullFileName = Left$(strFullFileName, intPos)
 If Len(Dir$(strFullFileName)) = 0 Then strFullFileName = ""
 pathOf = strFullFileName
End Function

Public Function pointColumnHeading() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrPointColumnHeading = mobjIniFile.getValue("Report", "point column heading", mstrPointColumnHeading)
 End If
 pointColumnHeading = mstrPointColumnHeading
End Function

Public Function printButtonCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrPrintButtonCaption = mobjIniFile.getValue("Captions", "print button", mstrPrintButtonCaption)
 End If
 printButtonCaption = mstrPrintButtonCaption
End Function

Public Function printButtonTip() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrPrintButtonTip = mobjIniFile.getValue("Tooltips", "print button", mstrPrintButtonTip)
 End If
 printButtonTip = mstrPrintButtonTip
End Function

Public Function procedureColumnHeading() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrProcedureColumnHeading = mobjIniFile.getValue("Report", "procedure column heading", mstrProcedureColumnHeading)
 End If
 procedureColumnHeading = mstrProcedureColumnHeading
End Function

Public Function programCaption() As String
 Dim intPos As Integer
 Dim strVersion As String
 If Not (mobjIniFile Is Nothing) Then
   mstrProgramCaption = mobjIniFile.getValue("Captions", "program title", mstrProgramCaption)
 End If
 intPos = InStr(1, mstrProgramCaption, "%1%", vbTextCompare)
 If intPos > 0 Then
   strVersion = App.Major & "." & App.Minor & App.Revision
   mstrProgramCaption = Left$(mstrProgramCaption, intPos - 1) & strVersion & Mid$(mstrProgramCaption, intPos + 3)
 End If
 programCaption = mstrProgramCaption
End Function

Public Function projectFileDescription() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrProjectFileType = mobjIniFile.getValue("Captions", "project file type", mstrProjectFileType)
 End If
 projectFileDescription = mstrProjectFileType
End Function

Private Function rememberDirectory() As Boolean
 If Not (mobjIniFile Is Nothing) Then
   mysnRememberDirectory = mobjIniFile.getValue("Settings", "remember directory", mysnRememberDirectory)
 End If
 rememberDirectory = mysnRememberDirectory
End Function

Private Sub setDefaults()
 mstrComplexityAxisDescription = "Complexity"
 mstrComplexityColumnHeading = "Compl."
 mstrComplexitySuffix = "structure statement(s)"
 mstrExitButtonCaption = "E&xit"
 mstrExitButtonTip = "Close the application"
 mstrFileNotFound = "File ""%1%"" not found. Please try again."
 mstrFileSelectorCaption = "Please select a Visual Basic Project File"
 mstrFileToLoad = ""
 mstrHelpButtonCaption = "&Help"
 mstrHelpButtonTip = "Don't you understand? Click here!"
 mstrHelpFile = App.Path & "\ohno.hlp"
 mstrLinesAxisDescription = "Lines of Code"
 mstrLinesColumnHeading = "Lines"
 mstrLinesSuffix = "lines"
 mstrOpenButtonTip = "Open a Visual Basic Project file"
 mstrOpenButtonCaption = "&Open"
 mstrPrintButtonCaption = "&Print"
 mstrPrintButtonTip = "Print a report"
 mstrProgramCaption = "OH NO! analyzer version %1%"
 mstrProjectFileType = "Visual Basic Project Files"
 mstrParametersColumnHeading = "Par.'s"
 mstrParameterSuffix = "parameter(s)"
 mstrPointColumnHeading = "pt."
 mstrProcedureColumnHeading = "Procedure name"
 mstrWindowCaption = "Procedure data"
 mysnRememberDirectory = True
End Sub

Public Sub setOpenDirectory(ByVal strFullPath As String)
 Dim strJustPath As String
 If rememberDirectory Then
   strJustPath = pathOf(strFullPath)
   If Len(strJustPath) > 0 Then
     SaveSetting "OHNO", "Settings", "directory", strJustPath
     mstrPreviousDirectory = strFullPath
   End If
 End If
End Sub

Private Function stripQuotes(ByVal strText As String) As String
 Dim strResult As String
 strResult = Trim$(strText)
 If Left$(strResult, 1) = """" And Right$(strResult, 1) = """" Then
   strResult = Mid$(strResult, 2, Len(strResult) - 2)
 End If
 stripQuotes = strResult
End Function

Public Function windowCaption() As String
 If Not (mobjIniFile Is Nothing) Then
   mstrWindowCaption = mobjIniFile.getValue("Spot popup", "window caption", mstrWindowCaption)
 End If
 windowCaption = mstrWindowCaption
End Function

