VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsAssert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Compare Binary
Option Explicit
'Last update: 2002/01/24

Private Const ERRBASE As Long = -2147220334
Private mstrNames() As String
Private mvarVariables() As Variant

Private Sub Class_Initialize()
 ReDim mstrNames(0 To 0)
 ReDim mvarVariables(0 To 0)
End Sub

Public Function countOfValues() As Integer
 countOfValues = UBound(mvarVariables)
End Function

Private Sub deleteValue(ByVal intWhich As Integer)
 Dim intCnt As Integer
 intCnt = intWhich
 While intCnt < countOfValues - 1
      mstrNames(intCnt) = mstrNames(intCnt + 1)
      mvarVariables(intCnt) = mvarVariables(intCnt + 1)
      intCnt = intCnt + 1
 Wend
 ReDim Preserve mstrNames(0 To countOfValues - 1)
 ReDim Preserve mvarVariables(0 To countOfValues - 1)
 mvarVariables(countOfValues) = Empty
 mstrNames(countOfValues) = ""
End Sub

Public Sub ensure(ByVal ysnCondition As Boolean, Optional ByVal strMessage As String = "")
'Check the if a function or method did what is was supposed to.
 If Not ysnCondition Then Err.Raise ERRBASE + 2, "ClsAssert.ensure", "Postcondition """ & strMessage & """ not satisfied (the function did not do its work properly)."
End Sub

Private Function findValueName(ByVal strName As String) As Integer
 findValueName = -1
 Dim intCnt As Integer
 strName = UCase$(strName)
 intCnt = countOfValues - 1
 While intCnt >= 0
      If strName = UCase$(mstrNames(intCnt)) Then
        findValueName = intCnt
        intCnt = -2
      End If
      intCnt = intCnt - 1
 Wend
End Function

Public Function getValue(ByVal strName As String) As Variant
 Dim intCnt As Integer
 intCnt = findValueName(strName)
 If intCnt >= 0 Then
   getValue = mvarVariables(intCnt)
   deleteValue intCnt
 Else
   Err.Raise ERRBASE + 4, "ClsAssert.getValue", "Buffered value not found."
 End If
End Function

Public Sub require(ByVal ysnCondition As Boolean, Optional ByVal strMessage As String = "")
'Check the preconditions of a function or method
 If Not ysnCondition Then Err.Raise ERRBASE + 1, "ClsAssert.require", "Precondition """ & strMessage & """ not satisfied (wrong situation for calling this function)."
End Sub

Public Sub setValue(ByVal strName As String, ByVal varValue As Variant)
 Dim intIndex As Integer
 intIndex = findValueName(strName)
 If intIndex < 0 Then
    intIndex = countOfValues
    ReDim Preserve mstrNames(0 To countOfValues + 1)
    ReDim Preserve mvarVariables(0 To countOfValues + 1)
 End If
 mstrNames(intIndex) = strName
 mvarVariables(intIndex) = varValue
End Sub

Public Sub shouldNeverReachHere(Optional ByVal strMessage As String = "")
'set a trap to test certain conditions are adequately dealt with
 Err.Raise ERRBASE + 3, "ClsAssert.shouldNeverReachHere", "Forbidden code """ & strMessage & """ was going to be executed."
End Sub
