VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsErrorLog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Compare Binary
Option Explicit

'Last update: 2002/02/08

Private Const ERRBASE As Long = -2147217656
Private mysnInProcessMode As Boolean
Private mintEmployeeNr As Integer
Private mstrLogFile As String

Public Enum enmErrorMode
    SILENTMODE_ON = 0
    SILENTMODE_OFF = 1
End Enum

Private Sub Class_Initialize()
 On Error Resume Next
 mstrLogFile = App.Path & "\" & App.EXEName & ".log"
 mintEmployeeNr = getCurrentUserId
 mysnInProcessMode = False
End Sub

Public Sub construct(Optional ByVal strFileName As String = "", Optional ByVal ysnProcess As Boolean = False)
Attribute construct.VB_Description = "The constructor"
 Static ysnHasRunBefore As Boolean
 If ysnHasRunBefore Then
   Err.Raise ERRBASE + 1, "ClsErrorLog.construct", "Construct method can only be used once."
 Else
   If Len(strFileName) = 0 Then strFileName = App.EXEName & ".LOG"
   If InStr(1, strFileName, "\") = 0 Then strFileName = App.Path & "\" & strFileName
   mstrLogFile = strFileName
   mysnInProcessMode = ysnProcess
   ysnHasRunBefore = True
 End If
End Sub

Private Function getCurrentUserId() As Integer
 Dim strEnv As String
 Dim intIndex As Integer
 Dim intResult As Integer
 getCurrentUserId = 0
 intIndex = 1
 intResult = 0
 strEnv = Environ$(intIndex)
 While Len(strEnv) > 0 And intResult = 0
      If UCase$(Left$(strEnv, 4)) = "WNR=" Then
        intResult = CInt(Mid$(strEnv, 5))
      End If
      intIndex = intIndex + 1
      strEnv = Environ$(intIndex)
 Wend
 getCurrentUserId = intResult
End Function

Public Sub logError(ByVal strLogPosition As String, ByVal bytSilentMode As enmErrorMode)
 writeError Err.Description, strLogPosition & " (" & Err.Source & ")", bytSilentMode
End Sub

Public Sub writeError(ByVal strMessage As String, ByVal strForm As String, ByVal bytSilentMode As enmErrorMode)
Attribute writeError.VB_Description = "DEPRECATED. use logError instead."
Attribute writeError.VB_MemberFlags = "40"
'DEPRECATED. Use logError instead.
'Writes an error message to a log file. The log file is located in the same directory
'as the application and has the same name, but an extension ".log". If bytSilentMode
'is not SILENTMODE_OFF, then the user gets a warning.
 On Error Resume Next 'No recursive error calls
 writeErrorToFile strMessage, strForm
 If bytSilentMode = enmErrorMode.SILENTMODE_OFF And Not mysnInProcessMode Then
   MsgBox strMessage, 4112, strForm
 End If
End Sub

Private Sub writeErrorToFile(ByVal strMessage As String, ByVal strForm As String)
 On Error GoTo Err_writeErrorToFile
 Dim intFileNumber As Integer
 intFileNumber = FreeFile
 Open mstrLogFile For Append As #intFileNumber
 On Error GoTo close_first
 Print #intFileNumber, Format$(Now, "yyyy mmm d ddd - hh:nn:ss"); " -> "; strMessage; " ; "; strForm; _
                       IIf(mintEmployeeNr <> 0, " ; User: " & mintEmployeeNr, "")
 Close #intFileNumber
Exit_writeErrorToFile:
 Exit Sub
close_first:
 On Error Resume Next
 Close #intFileNumber
Err_writeErrorToFile:
 MsgBox "Unable to log the next error. Please inform the software department.", vbExclamation, "Important!"
 Resume Exit_writeErrorToFile
End Sub
