VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsFileChooser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Last update: 2002/02/26

'example of usage:
' Dim strFileName
' Dim strLine As String
' Dim intFile As Integer
' With New ClsFileChooser
'     .setFilter "Text Files (*.txt)" & Chr$(0) & "*.txt" & Chr$(0) & "All Files (*.*)" & Chr$(0) & "*.*" & Chr$(0)
'     .setInitialDir "C:\"
'     .setFlags .FILEMUSTEXIST
'     strFileName = .getFilenameForOpen(Me.hWnd) ' a Form's window handle or 0
' End With
' If Len(strFileName) > 0 Then
'   If Len(Dir$(strFileName)) > 0 Then
'     intFile = FreeFile
'     Open strFileName For Input As intFile
'     While Not EOF(intFile)
'          Line Input #intFile, strLine
'          Debug.Print strLine
'     Wend
'     Close intFile
'   Else
'     MsgBox "file does not exist"
'   End If
' Else
'   MsgBox "No file selected"
' End If

Private Type OpenFileName
    lngSizeOfDataStructure As Long
    lngHwndOwner As Long
    hInstance As Long
    strFiletypeFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    lngFilterIndex As Long
    strFilenameBuffer As String
    lngLengthOfFilenameBuffer As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    strInitialDirectory As String
    strDialogTitle As String
    lngFlags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Declare Function apiGetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFileName) As Long
Private Declare Function apiGetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFileName) As Long

Private mtypDialogData As OpenFileName

'constants:
Public Function READONLY() As Long
 READONLY = 1
End Function

Public Function CONFIRMREPLACE() As Long
 CONFIRMREPLACE = 2
End Function

Public Function HIDEREADONLY() As Long
 HIDEREADONLY = 4
End Function

Public Function ALLOWMULTISELECT() As Long
 ALLOWMULTISELECT = &H200
End Function

Public Function FILEMUSTEXIST() As Long
 FILEMUSTEXIST = &H1000
End Function

Public Function PROMPTTOCREATE() As Long
 PROMPTTOCREATE = &H2000
End Function

Public Function DONTADDTORECENT() As Long
 DONTADDTORECENT = &H2000000
End Function

Public Function FORCESHOWHIDDEN() As Long
 FORCESHOWHIDDEN = &H10000000
End Function

Private Sub Class_Initialize()
 mtypDialogData.lngSizeOfDataStructure = Len(mtypDialogData)
 mtypDialogData.hInstance = App.hInstance
 mtypDialogData.lpstrFileTitle = Space$(254) 'Create a buffer for the file title
 mtypDialogData.nMaxFileTitle = 255 'Set the maximum length of a returned file title
 setTitle "Select a file"
 setInitialDir "C:\"
 setFilter "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
 mtypDialogData.lngFlags = 0 'No flags
End Sub

Public Function flags() As Long
 flags = mtypDialogData.lngFlags
End Function

Public Function getFilenameForOpen(ByVal lngHwnd As Long) As String
 getFilenameForOpen = ""
 setHwnd lngHwnd
 mtypDialogData.strFilenameBuffer = Space$(254) 'create a buffer for the file
 mtypDialogData.lngLengthOfFilenameBuffer = 255 'set the maximum length of a returned file
 'Show the 'Open File'-dialog
 If apiGetOpenFileName(mtypDialogData) Then
   getFilenameForOpen = strip(mtypDialogData.strFilenameBuffer)
 End If
End Function

Private Function strip(ByVal strNogwat As String) As String
 Dim strResult As String
 Dim intPos As Integer
 strResult = Trim$(strNogwat)
 intPos = InStr(1, strResult, Chr$(0), vbBinaryCompare)
 If intPos > 0 Then
   strResult = Left$(strResult, intPos - 1)
 End If
 strip = strResult
End Function

Public Function getFilenameForSave(ByVal lngHwnd As Long) As String
 getFilenameForSave = ""
 setHwnd lngHwnd
 mtypDialogData.strFilenameBuffer = Space$(254) 'create a buffer for the file
 mtypDialogData.lngLengthOfFilenameBuffer = 255 'set the maximum length of a returned file
 'Show the 'Open File'-dialog
 If apiGetSaveFileName(mtypDialogData) Then
   getFilenameForSave = strip(mtypDialogData.strFilenameBuffer)
 End If
End Function

Public Function isReadOnly() As Boolean
 isReadOnly = ((mtypDialogData.lngFlags And READONLY) <> 0)
End Function

Public Sub setFilter(ByVal strFilter As String, Optional ByVal lngIndex As Long = 0)
 mtypDialogData.strFiletypeFilter = strFilter
 mtypDialogData.lngFilterIndex = lngIndex
End Sub

Public Sub setFlags(ByVal lngFlags As Long)
 mtypDialogData.lngFlags = lngFlags
End Sub

Private Sub setHwnd(ByVal lngHwnd As Long)
 mtypDialogData.lngHwndOwner = lngHwnd
End Sub

Public Sub setInitialDir(ByVal strDir As String)
 mtypDialogData.strInitialDirectory = strDir
End Sub

Public Sub setTitle(ByVal strTitle As String)
 mtypDialogData.strDialogTitle = strTitle
End Sub

