VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ClsInifile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'Last update: 2001/12/13

Private Const ERRBASE As Long = -2147215264

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Private mstrIniApp As String * 260
Private mstrIniKey As String * 260
Private mstrIniVal As String * 260
Private mstrIniFil As String * 260
Private mstrIniDef As String * 260
Private mstrFileName As String

Public Sub construct(Optional ByVal strIniFile As String = "", Optional ByVal ysnCreateIfNonexisting As Boolean = True)
Attribute construct.VB_Description = "Constructor"
'runs once
 Static ysnHasRunBefore As Boolean
 If Not ysnHasRunBefore Then
   If strIniFile = "" Then
     strIniFile = App.Path & "\" & App.EXEName & ".ini"
   End If
   If Dir$(strIniFile) = "" Then
     If ysnCreateIfNonexisting Then
       createEmptyFile strIniFile
     Else
       Err.Raise ERRBASE + 1, "ClsInifile", ".INI file not found."
     End If
   End If
   mstrFileName = strIniFile
   ysnHasRunBefore = True
 End If
End Sub

Private Sub createEmptyFile(ByVal strIniFile As String)
 Dim intFile As Integer
 intFile = FreeFile
 Open strIniFile For Output As intFile
 Print #intFile, "; automatically created on "; Format(Now, "yyyy/mm/dd hh:nn")
 Close intFile
 While Len(Dir$(strIniFile)) = 0
      DoEvents: DoEvents
 Wend
End Sub

Public Function filename() As String
Attribute filename.VB_Description = "The full path of the ini file"
 filename = mstrFileName
End Function

Public Function getValue(ByVal strSection As String, ByVal strKey As String, Optional ByVal strDefault As String = "") As String
Attribute getValue.VB_Description = "Get a value from the ini file. Suffers from timing problems"
Attribute getValue.VB_UserMemId = 0
 getValue = ""
 mstrIniApp = strSection & vbNullChar
 mstrIniKey = strKey & vbNullChar
 mstrIniDef = strDefault & vbNullChar
 mstrIniFil = mstrFileName & vbNullChar
 If GetPrivateProfileString(mstrIniApp, mstrIniKey, mstrIniDef, mstrIniVal, 260&, mstrIniFil) <> 0 Then
   getValue = Left$(mstrIniVal, InStr(1, mstrIniVal, vbNullChar, vbBinaryCompare) - 1)
 End If
End Function

Public Function setValue(ByVal strSection As String, ByVal strKey As String, ByVal valValue As Variant) As String
Attribute setValue.VB_Description = "Set or create a value in the ini file. Suffers from timing problems"
 setValue = ""
 mstrIniApp = strSection & vbNullChar
 mstrIniKey = strKey & vbNullChar
 If VarType(valValue) = vbString Then
   mstrIniVal = valValue & vbNullChar
 Else
   mstrIniVal = CStr(valValue) & vbNullChar
 End If
 mstrIniFil = mstrFileName & vbNullChar
 If WritePrivateProfileString(mstrIniApp, mstrIniKey, mstrIniVal, mstrIniFil) <> 0 Then
   setValue = CStr(valValue)
 End If
End Function


