VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsReportGenerator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/04/21

'public class ClsReportGenerator
Private Const ERRBASE As Long = -2147209154 'RG
Private Const CM As Long = 567

Private mobjProject As ClsVbProject
Private mobjSettings As ClsApplicationSettings
Private mobjSpotGraph As ClsSpotGraph
Private mobjProcedures As ClsVbProcedures
Private msngDistance() As Single
Private mlngIndex() As Long
Private mlngProcsToShow As Long

Private Sub Class_Initialize()
 ReDim msngDistance(0 To 0)
 ReDim mlngIndex(0 To 0)
End Sub

Private Sub Class_Terminate()
 Dim lngCount As Long
 lngCount = count - 1
 Set mobjProcedures = Nothing
 Set mobjProject = Nothing
 Set mobjSpotGraph = Nothing
End Sub

Public Sub construct(ByRef objPrj As ClsVbProject, ByRef objGraph As ClsSpotGraph, ByRef objProcedures As ClsVbProcedures, ByVal lngNumberOfProceduresToList As Long, ByRef objSettings As ClsApplicationSettings)
 Static ysnHasRunbefore As Boolean
 If ysnHasRunbefore Then
   Err.Raise ERRBASE + 1, "ClsReportGenerator.construct", "Construct method can only be used once."
 Else
   If objPrj Is Nothing Then Err.Raise ERRBASE + 2, "ClsReportGenerator.construct", "Project cannot be an empty object."
   If objGraph Is Nothing Then Err.Raise ERRBASE + 2, "ClsReportGenerator.construct", "SpotGraph cannot be an empty object."
   If objProcedures Is Nothing Then Err.Raise ERRBASE + 2, "ClsReportGenerator.construct", "Procedures collection cannot be an empty object."
   If objSettings Is Nothing Then Err.Raise ERRBASE + 2, "ClsReportGenerator.construct", "Settings cannot be an empty object."
   Set mobjProject = objPrj
   Set mobjSpotGraph = objGraph
   Set mobjProcedures = objProcedures
   Set mobjSettings = objSettings
   mlngProcsToShow = lngNumberOfProceduresToList
   printReport
 End If
End Sub

Private Function count() As Long
 count = UBound(mlngIndex)
End Function

Private Sub drawArrows()
 Printer.FontSize = 10
 drawHorizontalArrow 3 * CM + 0.25 * Printer.ScaleWidth, 2.8 * CM + 0.5 * Printer.ScaleHeight, 2 * CM
 Printer.CurrentX = 0.25 * Printer.ScaleWidth + 3.5 * CM
 Printer.CurrentY = 2.6 * CM + 0.5 * Printer.ScaleHeight
 Printer.Print mobjSettings.complexityAxisDescription;
 Printer.CurrentX = 2.5 * CM + 0.5 * Printer.ScaleWidth
 Printer.Print CStr(mobjProject.maxComplexity)
 drawVerticalArrow 4 * CM + 0.5 * Printer.ScaleWidth, 3 * CM + 0.25 * Printer.ScaleHeight, 2 * CM
 drawMultilineText mobjSettings.linesAxisDescription, 4.5 * CM + 0.5 * Printer.ScaleWidth, 2 * CM + 0.25 * Printer.ScaleHeight
 Printer.CurrentX = 4 * CM + 0.5 * Printer.ScaleWidth
 Printer.CurrentY = 1.7 * CM + 0.5 * Printer.ScaleHeight
 Printer.Print CStr(mobjProject.maxLinesOfCode)
End Sub

Private Sub drawHorizontalArrow(ByVal sngHeadPositionX As Single, ByVal sngHeadPositionY As Single, ByVal sngLength As Single)
 Dim objStartPoint As New ClsVector2d
 Dim sngPi As Single
 sngPi = 4 * Atn(1)
 objStartPoint.construct sngHeadPositionX, sngHeadPositionY
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi, sngLength)
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi * 5 / 6, 0.2 * sngLength)
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi * 7 / 6, 0.2 * sngLength)
 Set objStartPoint = Nothing
End Sub

Private Sub drawLine(ByRef objPoint1 As ClsVector2d, ByRef objPoint2 As ClsVector2d)
 Printer.Line (objPoint1.x, objPoint1.y)-(objPoint2.x, objPoint2.y), vbBlack
End Sub

Private Sub drawMultilineText(ByVal strText As String, ByVal sngX As Single, ByVal sngY As Single)
 Dim strLine() As String
 Dim intPos As Integer
 Dim bytCount As Byte
 ReDim strLine(0 To 0)
 strText = Trim$(strText)
 intPos = InStr(1, strText, " ", vbTextCompare)
 While intPos > 0
      strLine(UBound(strLine)) = Left$(strText, intPos - 1)
      strText = Mid$(strText, intPos + 1)
      ReDim Preserve strLine(0 To UBound(strLine) + 1)
      intPos = InStr(1, strText, " ", vbTextCompare)
 Wend
 strLine(UBound(strLine)) = strText
 Printer.CurrentY = sngY - UBound(strLine) * 0.5 * CM
 For bytCount = 0 To UBound(strLine)
    Printer.CurrentX = sngX
    Printer.Print strLine(bytCount)
 Next bytCount
End Sub

Private Sub drawVerticalArrow(ByVal sngHeadPositionX As Single, ByVal sngHeadPositionY As Single, ByVal sngLength As Single)
 Dim objStartPoint As New ClsVector2d
 Dim sngPi As Single
 sngPi = 4 * Atn(1)
 objStartPoint.construct sngHeadPositionX, sngHeadPositionY
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi * 1.5, sngLength)
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi * 8 / 6, 0.2 * sngLength)
 drawLine objStartPoint, objStartPoint.polarFrom(sngPi * 10 / 6, 0.2 * sngLength)
 Set objStartPoint = Nothing
End Sub

Private Sub printLabels()
 Dim lngCount As Long
 Dim lngMax As Long
 Dim bytFontSize As Byte
 lngMax = mobjProcedures.count
 lngCount = 1
 setLabelFont bytFontSize
 While lngCount <= lngMax
      If mobjSpotGraph.hasId(mobjProcedures.IdOf(lngCount)) Then
        mobjSpotGraph.setPositionForId mobjProcedures.IdOf(lngCount)
        Printer.Print lngCount;
      End If
      lngCount = lngCount + 1
 Wend
 unsetLabelFont bytFontSize
End Sub

Private Sub printList()
 printLabels
 mobjSpotGraph.setPrinterTextCursor
 printListHeader
 printListRows
 Printer.EndDoc
End Sub

Private Sub printListHeader()
 Printer.Print vbCrLf; vbCrLf
 With Printer
     .FontSize = 10
     .FontItalic = True
     .FontUnderline = True
 End With
 printStringAt mobjSettings.pointColumnHeading, 2 * CM
 printStringAt mobjSettings.procedureColumnHeading, 3 * CM
 printStringAt mobjSettings.linesColumnHeading, 14 * CM
 printStringAt mobjSettings.complexityColumnHeading, 15.5 * CM
 printStringAt mobjSettings.parametersColumnHeading, 17 * CM
 Printer.Print
 With Printer
     .FontUnderline = False
     .FontItalic = False
 End With
End Sub

Private Sub printListRows()
 Dim lngCount As Long
 Dim lngMax As Long
 lngCount = 1
 If mlngProcsToShow <= 0 Then
   lngMax = mobjProcedures.count
 Else
   lngMax = mlngProcsToShow
 End If
 While lngCount <= lngMax
      printRow lngCount, mobjProcedures.item(lngCount)
      lngCount = lngCount + 1
 Wend
End Sub

Private Sub printReport()
 On Error Resume Next
 Printer.PrintQuality = vbPRPQHigh
 On Error GoTo 0
 printReportHeader
 mobjSpotGraph.setMarginsForPrinting 3 * CM, 2 * CM
 mobjSpotGraph.drawToPrinter
 If Not mobjProcedures.isSorted Then mobjProcedures.sortByDistance
 drawArrows
 printList
End Sub

Private Sub printReportDate()
 With Printer
     .FontSize = 8
     .CurrentY = 1 * CM
     .CurrentX = .ScaleLeft + .ScaleWidth - 4 * CM
     Printer.Print Format$(Now, "Long Date")
 End With
End Sub

Private Sub printReportHeader()
 With Printer
     .CurrentX = 2 * CM
     .CurrentY = 1 * CM
     .FontSize = 20
     .FontBold = True
     Printer.Print mobjProject.name
     .FontBold = False
 End With
 printReportDate
End Sub

Private Sub printRow(ByVal lngNumber As Long, ByRef objProcedure As ClsVbProcedure)
 printStringAt CStr(lngNumber), 2 * CM
 printStringAt objProcedure.parent.name & "." & objProcedure.name, 3 * CM
 printStringAt CStr(objProcedure.linesOfCode), 14 * CM
 printStringAt CStr(objProcedure.complexity), 15.5 * CM
 printStringAt CStr(objProcedure.numberOfParameters), 17 * CM
 Printer.Print
End Sub

Private Function printStringAt(ByVal strWhat As String, ByVal lngLocation As Long)
 Printer.CurrentX = lngLocation
 Printer.Print strWhat;
End Function

Private Sub setLabelFont(ByRef bytFontSizeSave As Byte)
 With Printer
     bytFontSizeSave = .FontSize
     .FontSize = 6
     .FillStyle = vbFSTransparent
     .FontTransparent = True
 End With
End Sub

Private Sub unsetLabelFont(ByVal bytFontSizeSave As Byte)
 With Printer
     .FillStyle = vbFSSolid
     .FontSize = bytFontSizeSave
 End With
End Sub
