VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsSpotGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/04/08

'public class ClsSpotGraph
Private Const ERRBASE As Long = -2147208478 'SG
Private Const GRAY50 As Long = 8421504 'RGB(128, 128, 128)

Private WithEvents mpicLinen As PictureBox
Attribute mpicLinen.VB_VarHelpID = -1
Private msngX() As Single
Private msngY() As Single
Private msngSizeX() As Single
Private msngSizeY() As Single
Private mlngColour() As Long
Private mlngId() As Long
Private mstrTooltip() As String
Private msngSpotSize As Single
Private mintHorizontalDivisionLines As Integer
Private mintVerticalDivisionLines As Integer
Private msngMouseX As Single
Private msngMouseY As Single
Private mysnIsConstructed As Boolean
Private mlngMarginX As Long
Private mlngMarginY As Long

Public Event doubleClick(ByVal lngId As Long, ByVal strTooltip As String)

Public Sub add(ByVal sngX As Single, ByVal sngY As Single, ByVal lngColour As Long, ByVal lngId As Long, Optional ByVal strTooltip As String = "", Optional ByVal sngSizeX As Single = 0, Optional ByVal sngSizeY As Single = 0)
 Dim lngCount As Long
 checkIfConstructed
 If sngX < 0 Or sngY < 0 Then Err.Raise ERRBASE + 3, "ClsSpotGraph.add", "Coordinates must be positive or zero."
 If sngSizeX < 0 Or sngSizeY < 0 Then Err.Raise ERRBASE + 3, "ClsSpotGraph.add", "Point Sizes must be positive or zero."
 If isIdStored(lngId) Then Err.Raise ERRBASE + 3, "ClsSpotGraph.add", "Id must be unique."
 fillInActualSize sngSizeX, sngSizeY
 lngCount = bestPlace(0, count - 1, sngSizeX * sngSizeY)
 takeOrMakePlace lngCount, sngX, sngY, sngSizeX, sngSizeY
 msngX(lngCount) = sngX
 msngY(lngCount) = sngY
 msngSizeX(lngCount) = sngSizeX
 msngSizeY(lngCount) = sngSizeY
 mlngColour(lngCount) = lngColour
 mlngId(lngCount) = lngId
 mstrTooltip(lngCount) = strTooltip
End Sub

Private Function areaOf(ByVal lngWhich) As Single
 areaOf = msngSizeY(lngWhich) * msngSizeX(lngWhich)
End Function

Private Function bestPlace(ByVal lngLowerBound As Long, ByVal lngUpperBound As Long, ByVal sngSoughtValue As Single) As Long
'perform binary search for the best place to insert the spot.
 Dim lngMid As Long
 If lngLowerBound > lngUpperBound Then
   bestPlace = lngLowerBound
 ElseIf sngSoughtValue > areaOf(lngLowerBound) Then
   bestPlace = lngLowerBound
 ElseIf sngSoughtValue <= areaOf(lngUpperBound) Then
   bestPlace = lngUpperBound + 1
 ElseIf lngUpperBound <= lngLowerBound + 1 Then
   If sngSoughtValue > areaOf(lngUpperBound) Then
     bestPlace = lngUpperBound
   End If
 Else
   lngMid = (lngLowerBound + lngUpperBound) \ 2
   If sngSoughtValue > areaOf(lngMid) Then
     bestPlace = bestPlace(lngLowerBound, lngMid, sngSoughtValue)
   Else
     bestPlace = bestPlace(lngMid, lngUpperBound, sngSoughtValue)
   End If
 End If
End Function

Private Sub checkIfConstructed()
 If Not mysnIsConstructed Then Err.Raise ERRBASE, "ClsSpotGraph.checkIfConstructed", "Please construct this poor little SpotGraph object first."
End Sub

Private Sub Class_Initialize()
 ReDim msngX(0 To 0)
 ReDim msngY(0 To 0)
 ReDim msngSizeX(0 To 0)
 ReDim msngSizeY(0 To 0)
 ReDim mlngColour(0 To 0)
 ReDim mlngId(0 To 0)
 ReDim mstrTooltip(0 To 0)
End Sub

Private Sub Class_Terminate()
 clear
End Sub

Public Sub clear()
 checkIfConstructed
 If Not (mpicLinen Is Nothing) Then mpicLinen.ToolTipText = ""
 Set mpicLinen = Nothing
End Sub

Public Sub construct(ByRef picLinen As PictureBox, Optional ByVal sngSpotSizeInPercents As Single = 5)
 If mysnIsConstructed Then
   Err.Raise ERRBASE + 1, "ClsSpotGraph.construct", "Construct method can only be used once."
 Else
   If picLinen Is Nothing Then Err.Raise ERRBASE + 2, "ClsSpotGraph.construct", "Image cannot be an empty object."
   If sngSpotSizeInPercents <= 0 Then Err.Raise ERRBASE + 2, "ClsSpotGraph.construct", "Spot size must be positive."
   picLinen.ScaleMode = vbPixels
   Set mpicLinen = picLinen
   msngSpotSize = 0.5 * sngSpotSizeInPercents
   mysnIsConstructed = True
 End If
End Sub

Private Function count() As Long
 count = UBound(mlngColour)
End Function

Public Sub draw()
 Dim lngCount As Long
 Dim sngXScale As Single
 Dim sngYScale As Single
 checkIfConstructed
 drawGrid
 lngCount = 0
 sngXScale = 0.01 * mpicLinen.ScaleWidth
 sngYScale = 0.01 * mpicLinen.ScaleHeight
 While lngCount < count
      mpicLinen.FillColor = mlngColour(lngCount)
      mpicLinen.Line ((msngX(lngCount) - msngSizeX(lngCount)) * sngXScale, (msngY(lngCount) - msngSizeY(lngCount)) * sngYScale)-((msngX(lngCount) + msngSizeX(lngCount)) * sngXScale, (msngY(lngCount) + msngSizeY(lngCount)) * sngYScale), GRAY50, B
      lngCount = lngCount + 1
 Wend
End Sub

Public Sub drawToPrinter()
 Dim lngCount As Long
 Dim sngXScale As Single
 Dim sngYScale As Single
 checkIfConstructed
 Printer.FillColor = vbBlack
 drawGridToPrinter
 lngCount = 0
 sngXScale = 0.01 * 0.5 * Printer.ScaleWidth
 sngYScale = 0.01 * 0.5 * Printer.ScaleHeight
 printHeader
 While lngCount < count
      Printer.FillColor = mlngColour(lngCount)
      Printer.Line (mlngMarginX + (msngX(lngCount) - msngSizeX(lngCount)) * sngXScale, mlngMarginY + (msngY(lngCount) - msngSizeY(lngCount)) * sngYScale)-(mlngMarginX + (msngX(lngCount) + msngSizeX(lngCount)) * sngXScale, mlngMarginY + (msngY(lngCount) + msngSizeY(lngCount)) * sngYScale), vbBlack, B
      lngCount = lngCount + 1
 Wend
 setPrinterTextCursor
 Printer.FillColor = vbBlack
End Sub

Private Sub drawGrid()
 If mintHorizontalDivisionLines > 1 Then drawHorizontalGridLines
 If mintVerticalDivisionLines > 1 Then drawVerticalGridLines
End Sub

Private Sub drawGridToPrinter()
 If mintHorizontalDivisionLines > 1 Then drawHorizontalGridLinesToPrinter
 If mintVerticalDivisionLines > 1 Then drawVerticalGridLinesToPrinter
End Sub

Private Sub drawHorizontalGridLines()
 Dim sngYFactor As Single
 Dim intCount As Integer
 sngYFactor = 1# * mpicLinen.ScaleHeight / mintHorizontalDivisionLines
 intCount = mintHorizontalDivisionLines - 1
 While intCount > 0
      mpicLinen.Line (0, intCount * sngYFactor)-(mpicLinen.ScaleWidth, intCount * sngYFactor), GRAY50
      intCount = intCount - 1
 Wend
End Sub

Private Sub drawHorizontalGridLinesToPrinter()
 Dim sngYFactor As Single
 Dim intCount As Integer
 sngYFactor = 0.5 * Printer.ScaleHeight / mintHorizontalDivisionLines
 intCount = mintHorizontalDivisionLines
 While intCount >= 0
      Printer.Line (mlngMarginX, mlngMarginY + intCount * sngYFactor)-(mlngMarginX + 0.5 * Printer.ScaleWidth, mlngMarginY + intCount * sngYFactor), vbBlack
      intCount = intCount - 1
 Wend
End Sub

Private Sub drawVerticalGridLines()
 Dim sngXFactor As Single
 Dim intCount As Integer
 sngXFactor = 1# * mpicLinen.ScaleWidth / mintVerticalDivisionLines
 intCount = mintVerticalDivisionLines - 1
 While intCount > 0
      mpicLinen.Line (intCount * sngXFactor, 0)-(intCount * sngXFactor, mpicLinen.ScaleHeight), GRAY50
      intCount = intCount - 1
 Wend
End Sub

Private Sub drawVerticalGridLinesToPrinter()
 Dim sngXFactor As Single
 Dim intCount As Integer
 sngXFactor = 0.5 * Printer.ScaleWidth / mintVerticalDivisionLines
 intCount = mintVerticalDivisionLines
 While intCount >= 0
      Printer.Line (mlngMarginX + intCount * sngXFactor, mlngMarginY)-(mlngMarginX + intCount * sngXFactor, mlngMarginY + 0.5 * Printer.ScaleHeight), vbBlack
      intCount = intCount - 1
 Wend
End Sub

Private Sub fillInActualSize(ByRef sngWidth As Single, ByRef sngHeight As Single)
 If sngWidth = 0 Then
   sngWidth = msngSpotSize 'default size
 Else
   sngWidth = 0.5 * sngWidth 'We only need half the size
 End If
 If sngHeight = 0 Then
   sngHeight = sngWidth 'square spot
 Else
   sngHeight = 0.5 * sngHeight
 End If
End Sub

Private Function findById(ByVal lngId As Long) As Long
 Dim lngCount As Long
 lngCount = count - 1
 While lngCount >= 0
      If lngId = mlngId(lngCount) Then
        findById = lngCount
        lngCount = -5
      End If
      lngCount = lngCount - 1
 Wend
 If lngCount > -3 Then Err.Raise ERRBASE + 5, "ClsSpotGraph.findById", "Id " & lngId & " not found."
End Function

Public Function hasId(ByVal lngId As Long) As Boolean
 Dim lngCount As Long
 checkIfConstructed
 hasId = False
 lngCount = count - 1
 While lngCount >= 0
      If lngId = mlngId(lngCount) Then
        hasId = True
        lngCount = -5
      End If
      lngCount = lngCount - 1
 Wend
End Function

Private Function findOverlappingSpot(ByVal lngPlace As Long, ByVal sngX As Single, ByVal sngY As Single, ByVal sngSizeX As Single, ByVal sngSizeY As Single) As Long
 Dim lngResult As Long
 Dim ysnContinue As Boolean
 Dim sngArea As Single
 lngResult = -1
 sngArea = sngSizeX * sngSizeY
 If lngPlace > 0 Then
   lngPlace = lngPlace - 1
   ysnContinue = Abs(sngArea - msngSizeX(lngPlace) * msngSizeY(lngPlace)) < 0.001
   While ysnContinue
        If sngX = msngX(lngPlace) And sngY = msngY(lngPlace) And (sngSizeX = msngSizeX(lngPlace)) And (sngSizeY = msngSizeY(lngPlace)) Then
          lngResult = lngPlace
          lngPlace = 0
        End If
        lngPlace = lngPlace - 1
        ysnContinue = (lngPlace >= 0)
        If ysnContinue Then ysnContinue = Abs(sngArea - msngSizeX(lngPlace) * msngSizeY(lngPlace)) < 0.001
   Wend
 End If
 findOverlappingSpot = lngResult
End Function

Private Function indexOfSpotUnder(ByVal sngX As Single, ByVal sngY As Single) As Long
 Dim lngCount As Long
 indexOfSpotUnder = -1
 lngCount = count - 1
 While lngCount >= 0
      If isWithinSpot(sngX, sngY, lngCount) Then
        indexOfSpotUnder = lngCount
        lngCount = -1
      End If
      lngCount = lngCount - 1
 Wend
End Function

Private Function isIdStored(ByVal lngId As Long) As Boolean
 Dim lngCount As Long
 lngCount = count - 1
 isIdStored = False
 While lngCount >= 0
      If mlngId(lngCount) = lngId Then
        isIdStored = True
        lngCount = -1
      End If
      lngCount = lngCount - 1
 Wend
End Function

Private Function isWithinSpot(ByVal sngX As Single, ByVal sngY As Single, ByVal lngSpotCount As Long) As Boolean
 isWithinSpot = False
 If sngX >= msngX(lngSpotCount) - msngSizeX(lngSpotCount) Then
   If sngX <= msngX(lngSpotCount) + msngSizeX(lngSpotCount) Then
     If sngY >= msngY(lngSpotCount) - msngSizeY(lngSpotCount) Then
       isWithinSpot = sngY <= msngY(lngSpotCount) + msngSizeY(lngSpotCount)
     End If
   End If
 End If
End Function

Private Sub makeRoomAt(ByVal lngPlace As Long)
 Dim lngCount As Long
 lngCount = count + 1
 ReDim Preserve msngX(0 To lngCount)
 ReDim Preserve msngY(0 To lngCount)
 ReDim Preserve msngSizeX(0 To lngCount)
 ReDim Preserve msngSizeY(0 To lngCount)
 ReDim Preserve mlngColour(0 To lngCount)
 ReDim Preserve mstrTooltip(0 To lngCount)
 ReDim Preserve mlngId(0 To lngCount)
 lngCount = lngCount - 1
 While lngCount > lngPlace
      msngX(lngCount) = msngX(lngCount - 1)
      msngY(lngCount) = msngY(lngCount - 1)
      msngSizeX(lngCount) = msngSizeX(lngCount - 1)
      msngSizeY(lngCount) = msngSizeY(lngCount - 1)
      mlngColour(lngCount) = mlngColour(lngCount - 1)
      mstrTooltip(lngCount) = mstrTooltip(lngCount - 1)
      mlngId(lngCount) = mlngId(lngCount - 1)
      lngCount = lngCount - 1
 Wend
End Sub

Private Sub mpicLinen_DblClick()
 Dim lngCount As Long
 lngCount = indexOfSpotUnder(100 * msngMouseX / mpicLinen.ScaleWidth, 100 * msngMouseY / mpicLinen.ScaleHeight)
 If lngCount <> -1 Then RaiseEvent doubleClick(mlngId(lngCount), mstrTooltip(lngCount))
End Sub

Private Sub mpicLinen_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
 msngMouseX = x
 msngMouseY = y
End Sub

Private Sub mpicLinen_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
 Dim lngCount As Long
 lngCount = indexOfSpotUnder(100 * x / mpicLinen.ScaleWidth, 100 * y / mpicLinen.ScaleHeight)
 If lngCount = -1 Then
   mpicLinen.ToolTipText = ""
 Else
   mpicLinen.ToolTipText = mstrTooltip(lngCount)
 End If
End Sub

Private Sub mpicLinen_Resize()
 mpicLinen.Cls
 Me.draw
End Sub

Private Sub printHeader()
 Printer.FontName = "Arial"
 Printer.FontSize = 8
 Printer.FillStyle = vbFSSolid
 On Error Resume Next
 Printer.ColorMode = vbPRCMColor
 On Error GoTo 0
End Sub

Public Sub setDivisionLines(ByVal intHorizontal As Integer, ByVal intVertical As Integer)
 checkIfConstructed
 If (intHorizontal < 0) Or (intVertical < 0) Then Err.Raise ERRBASE + 4, "ClsSpotGraph.setDivisionLines", "Number of lines cannot be negative. Zero is allowed."
 mintHorizontalDivisionLines = intHorizontal
 mintVerticalDivisionLines = intVertical
End Sub

Public Sub setMarginsForPrinting(ByVal lngLeft As Long, ByVal lngTop As Long)
 checkIfConstructed
 If lngLeft < 0 Or lngTop < 0 Then Err.Raise ERRBASE + 6, "ClsSpotGraph.setMarginsForPrinting", "Margins cannot be negative."
 mlngMarginX = lngLeft
 mlngMarginY = lngTop
End Sub

Public Sub setPositionForId(ByVal lngId As Long)
 Dim lngCount As Long
 Dim sngXScale As Single
 Dim sngYScale As Single
 checkIfConstructed
 lngCount = findById(lngId)
 sngXScale = 0.01 * 0.5 * Printer.ScaleWidth
 sngYScale = 0.01 * 0.5 * Printer.ScaleHeight
 Printer.CurrentX = mlngMarginX + (msngX(lngCount) + msngSizeX(lngCount)) * sngXScale
 Printer.CurrentY = mlngMarginY + (msngY(lngCount) + msngSizeY(lngCount)) * sngYScale
End Sub

Public Sub setPrinterTextCursor()
 Printer.CurrentX = mlngMarginX
 Printer.CurrentY = mlngMarginY + 0.5 * Printer.ScaleHeight
End Sub

Private Sub takeOrMakePlace(ByRef lngPlace As Long, ByVal sngX As Single, ByVal sngY As Single, ByVal sngSizeX As Single, ByVal sngSizeY As Single)
 Dim lngNewPlace As Long
 lngNewPlace = findOverlappingSpot(lngPlace, sngX, sngY, sngSizeX, sngSizeY)
 If lngNewPlace < 0 Then
   makeRoomAt lngPlace
 Else
   lngPlace = lngNewPlace
 End If
End Sub
