VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsAssert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Last update: 2002/04/27
Implements IfcUnitTest
Private mobjTest As New ClsAssert
Private WithEvents mobjTestCountOfValues As ClsMethodTest
Attribute mobjTestCountOfValues.VB_VarHelpID = -1
Private WithEvents mobjTestEnsure As ClsMethodTest
Attribute mobjTestEnsure.VB_VarHelpID = -1
Private WithEvents mobjTestGetValue As ClsMethodTest
Attribute mobjTestGetValue.VB_VarHelpID = -1
Private WithEvents mobjTestRequire As ClsMethodTest
Attribute mobjTestRequire.VB_VarHelpID = -1
Private WithEvents mobjTestSetValue As ClsMethodTest
Attribute mobjTestSetValue.VB_VarHelpID = -1
Private WithEvents mobjTestShouldNeverReachHere As ClsMethodTest
Attribute mobjTestShouldNeverReachHere.VB_VarHelpID = -1

Private Sub Class_Initialize()
 initializeTests
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestCountOfValues = New ClsMethodTest
 Set mobjTestEnsure = New ClsMethodTest
 Set mobjTestGetValue = New ClsMethodTest
 Set mobjTestRequire = New ClsMethodTest
 Set mobjTestSetValue = New ClsMethodTest
 Set mobjTestShouldNeverReachHere = New ClsMethodTest
End Sub

Private Sub mobjTestCountOfValues_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestCountOfValues_onTest
 ysnCorrect = (mobjTest.countOfValues = 2)
 Exit Sub
Err_mobjTestCountOfValues_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestEnsure_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestEnsure_onTest
 mobjTest.ensure True, "Result that must be accomplished by the method."
 ysnCorrect = (lngError = 0)
 mobjTest.ensure False, "Result that is not accomplished by the method and raises an error."
 ysnCorrect = ysnCorrect And (lngError = -2147220332)
 lngError = 0
 Exit Sub
Err_mobjTestEnsure_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestGetValue_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestGetValue_onTest
 ysnCorrect = (mobjTest.getValue("librarianPhrase") = "Oook")
 ysnCorrect = ysnCorrect And (mobjTest.getValue("timeToPeelABanana") = 2.3)
 ysnCorrect = ysnCorrect And (mobjTest.countOfValues = 0)
 Exit Sub
Err_mobjTestGetValue_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestRequire_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestRequire_onTest
 mobjTest.require True, "Requirement that must be met before calling the method."
 ysnCorrect = (lngError = 0)
 mobjTest.require False, "Requirement that is not met before calling the method and therefore raises an error."
 ysnCorrect = ysnCorrect And (lngError = -2147220333)
 lngError = 0
 Exit Sub
Err_mobjTestRequire_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestSetValue_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestSetValue_onTest
 ysnCorrect = (mobjTest.countOfValues = 0)
 mobjTest.setValue "librarianPhrase", "Oook"
 mobjTest.setValue "timeToPeelABanana", 2.3
 Exit Sub
Err_mobjTestSetValue_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestShouldNeverReachHere_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestShouldNeverReachHere_onTest
 mobjTest.shouldNeverReachHere "Piece of obsolete code that should never be called."
 ysnCorrect = (lngError = -2147220331)
 lngError = 0
 Exit Sub
Err_mobjTestShouldNeverReachHere_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 gobjUnitTest.printStartOfClass "ClsAssert"
 ysnResult = mobjTestSetValue.runTest("setValue")
 ysnResult = ysnResult And mobjTestCountOfValues.runTest("countOfValues")
 ysnResult = ysnResult And mobjTestGetValue.runTest("getValue")
 ysnResult = ysnResult And mobjTestEnsure.runTest("ensure")
 ysnResult = ysnResult And mobjTestRequire.runTest("require")
 ysnResult = ysnResult And mobjTestShouldNeverReachHere.runTest("shouldNeverReachHere")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
