VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsErrorLog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Last update: 2002/05/16

Implements IfcUnitTest

Private mstrErrorFile As String
Private mobjTest As New ClsErrorLog
Private WithEvents mobjTestConstructor As ClsMethodTest
Attribute mobjTestConstructor.VB_VarHelpID = -1
Private WithEvents mobjTestLogError As ClsMethodTest
Attribute mobjTestLogError.VB_VarHelpID = -1
Private WithEvents mobjTestWriteError As ClsMethodTest
Attribute mobjTestWriteError.VB_VarHelpID = -1

Private Sub Class_Initialize()
 'Build little test environment. create files, objects, etc.
 mstrErrorFile = gobjUnitTest.GetTempPath & "ClsTest_ClsErrorLog.LOG"
 removeLog
 initializeTests
End Sub

Private Sub Class_Terminate()
 On Error Resume Next 'Clean up the test environment.
 removeLog
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestLogError = New ClsMethodTest
 Set mobjTestWriteError = New ClsMethodTest
End Sub

Private Function lineFromFile(ByVal strPath As String, ByVal intLineNumber As Integer) As String
 Dim intFile As Integer
 Dim strResult As String
 intFile = FreeFile
 Open mstrErrorFile For Input Shared As intFile
 While intLineNumber > 0
      Line Input #intFile, strResult
      intLineNumber = intLineNumber - 1
 Wend
 Close intFile
 lineFromFile = strResult
End Function

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 mobjTest.construct mstrErrorFile
 ysnCorrect = True 'No error raised
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestLogError_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestLogError_onTest
 Dim strLine As String
 On Error Resume Next
 Err.Raise vbObjectError + 1, "OtherClass.someMethod", "Second test"
 mobjTest.logError "UserInterface.event", SILENTMODE_ON
 Err.Clear
 On Error GoTo Err_mobjTestLogError_onTest
 strLine = lineFromFile(mstrErrorFile, 2) 'now read second line
 ysnCorrect = (InStr(1, strLine, "Second test", vbTextCompare) > 0)
 ysnCorrect = ysnCorrect And (InStr(1, strLine, "UserInterface.event (OtherClass.someMethod)", vbTextCompare) > 0)
 Exit Sub
Err_mobjTestLogError_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestWriteError_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestWriteError_onTest
 Dim intFile As Integer
 Dim strLine As String
 mobjTest.writeError "MESSAGE!", "CLASS.METHOD", SILENTMODE_ON
 strLine = lineFromFile(mstrErrorFile, 1)
 ysnCorrect = (InStr(1, strLine, "MESSAGE!", vbTextCompare) > 0)
 ysnCorrect = ysnCorrect And (InStr(1, strLine, "CLASS.METHOD", vbTextCompare) > 0)
 Exit Sub
Err_mobjTestWriteError_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub removeLog()
 If Len(Dir$(mstrErrorFile)) > 0 Then Kill mstrErrorFile
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsErrorLog"
 ysnResult = mobjTestConstructor.runTest("constructor")
 ysnResult = ysnResult And mobjTestWriteError.runTest("writeError")
 ysnResult = ysnResult And mobjTestLogError.runTest("logError")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
