VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsSpotGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'last update: 2002/04/20
Implements IfcUnitTest
 
Private mfrmTest As New frmTest_ClsSpotGraph
Private mobjTest As New ClsSpotGraph
Private WithEvents mobjTestAdd As ClsMethodTest
Attribute mobjTestAdd.VB_VarHelpID = -1
Private WithEvents mobjTestClear As ClsMethodTest
Attribute mobjTestClear.VB_VarHelpID = -1
Private WithEvents mobjTestConstructor As ClsMethodTest
Attribute mobjTestConstructor.VB_VarHelpID = -1
Private WithEvents mobjTestDraw As ClsMethodTest
Attribute mobjTestDraw.VB_VarHelpID = -1
Private WithEvents mobjTestHasId As ClsMethodTest
Attribute mobjTestHasId.VB_VarHelpID = -1
Private WithEvents mobjTestSetDivisionLines As ClsMethodTest
Attribute mobjTestSetDivisionLines.VB_VarHelpID = -1

Private Sub Class_Initialize()
 mfrmTest.Show
 While Not mfrmTest.Visible
      DoEvents
 Wend
 initializeTests
End Sub

Private Sub Class_Terminate()
 On Error Resume Next
 Unload mfrmTest
 Set mfrmTest = Nothing
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestAdd = New ClsMethodTest
 Set mobjTestClear = New ClsMethodTest
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestDraw = New ClsMethodTest
 Set mobjTestHasId = New ClsMethodTest
 Set mobjTestSetDivisionLines = New ClsMethodTest
End Sub

Private Sub mobjTestAdd_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestAdd_onTest
 mobjTest.add 20, 30, RGB(255, 0, 0), 1, "First"
 mobjTest.add 40, 60, RGB(0, 255, 0), 2, "Second", 6, 10
 ysnCorrect = (lngError = 0)
 mobjTest.add 50, 50, RGB(0, 0, 255), 1, "Third"  'no unique id
 ysnCorrect = ysnCorrect And (lngError = -2147208475)
 lngError = 0
 Exit Sub
Err_mobjTestAdd_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestClear_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestClear_onTest
 mobjTest.clear
 ysnCorrect = True 'no error raised
 Exit Sub
Err_mobjTestClear_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 mobjTest.add 2, 2, 255, 5, "Illegal before construction"
 ysnCorrect = (lngError = -2147208478)
 lngError = 0
 mobjTest.setDivisionLines 2, 4
 ysnCorrect = ysnCorrect And (lngError = -2147208478)
 lngError = 0
 mobjTest.draw
 ysnCorrect = ysnCorrect And (lngError = -2147208478)
 lngError = 0
 mobjTest.drawToPrinter
 ysnCorrect = ysnCorrect And (lngError = -2147208478)
 lngError = 0
 mobjTest.clear
 ysnCorrect = ysnCorrect And (lngError = -2147208478)
 lngError = 0
 mobjTest.construct mfrmTest.picTest
 ysnCorrect = ysnCorrect And (lngError = 0) 'No error raised
 mobjTest.construct mfrmTest.picTest, 4
 ysnCorrect = ysnCorrect And (lngError = -2147208477)
 lngError = 0
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestDraw_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestDraw_onTest
 mobjTest.draw
 ysnCorrect = True 'no error raised
 Exit Sub
Err_mobjTestDraw_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestHasId_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestHasId_onTest
 mobjTest.add 33, 35, RGB(255, 0, 0), 5, "First"
 mobjTest.add 33, 35, RGB(0, 255, 0), 6, "Second" 'one obscures the other
 ysnCorrect = mobjTest.hasId(5) Xor mobjTest.hasId(6)
 Exit Sub
Err_mobjTestHasId_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestSetDivisionLines_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestSetDivisionLines_onTest
 gobjUnitTest.printStartOfMethod "setDivisionLines"
 mobjTest.setDivisionLines -1, 5
 ysnCorrect = (lngError = -2147208474)
 lngError = 0
 mobjTest.setDivisionLines 2, 0
 ysnCorrect = ysnCorrect And (lngError = 0)
 Exit Sub
Err_mobjTestSetDivisionLines_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsSpotGraph"
 ysnResult = mobjTestConstructor.runTest("construct")
 ysnResult = ysnResult And mobjTestAdd.runTest("add")
 ysnResult = ysnResult And mobjTestHasId.runTest("hasId")
 ysnResult = ysnResult And mobjTestSetDivisionLines.runTest("setDivisionLines")
 ysnResult = ysnResult And mobjTestDraw.runTest("draw")
 ysnResult = ysnResult And mobjTestClear.runTest("clear")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
