VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsVbModule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'last update: 2002/04/20
Implements IfcUnitTest

Private mstrFile As String
Private mobjTest As New ClsVbModule
Private WithEvents mobjTestConstructor As ClsMethodTest
Attribute mobjTestConstructor.VB_VarHelpID = -1
Private WithEvents mobjTestCount As ClsMethodTest
Attribute mobjTestCount.VB_VarHelpID = -1
Private WithEvents mobjTestItem As ClsMethodTest
Attribute mobjTestItem.VB_VarHelpID = -1
Private WithEvents mobjTestMaxComplexity As ClsMethodTest
Attribute mobjTestMaxComplexity.VB_VarHelpID = -1
Private WithEvents mobjTestMaxLinesOfCode As ClsMethodTest
Attribute mobjTestMaxLinesOfCode.VB_VarHelpID = -1
Private WithEvents mobjTestMaxNumberOfParameters As ClsMethodTest
Attribute mobjTestMaxNumberOfParameters.VB_VarHelpID = -1
Private WithEvents mobjTestName As ClsMethodTest
Attribute mobjTestName.VB_VarHelpID = -1

Private Sub Class_Initialize()
 mstrFile = gobjUnitTest.GetTempPath & "vbModule.txt"
 deleteTextFile
 makeTextFile
 initializeTests
End Sub

Private Sub Class_Terminate()
 deleteTextFile
End Sub

Private Sub deleteTextFile()
 If Len(Dir$(mstrFile)) > 0 Then Kill mstrFile
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestCount = New ClsMethodTest
 Set mobjTestItem = New ClsMethodTest
 Set mobjTestMaxComplexity = New ClsMethodTest
 Set mobjTestMaxLinesOfCode = New ClsMethodTest
 Set mobjTestMaxNumberOfParameters = New ClsMethodTest
 Set mobjTestName = New ClsMethodTest
End Sub

Private Sub makeTextFile()
 Dim intFile As Integer
 intFile = FreeFile
 Open mstrFile For Output As intFile
 Print #intFile, "VERSION 1.0 CLASS"
 Print #intFile, "BEGIN"
 Print #intFile, "  MultiUse = -1  'True"
 Print #intFile, "  MTSTransactionMode  = 0  'NotAnMTSObject"
 Print #intFile, "END"
 Print #intFile, "SomeVar = BEGIN"
 Print #intFile, "  0035103103801381a3f81030"
 Print #intFile, "END"
 Print #intFile, "Attribute VB_GlobalNameSpace = False"
 Print #intFile, "Attribute VB_Creatable = False"
 Print #intFile, ""
 Print #intFile, "Option Compare Binary"
 Print #intFile, "Option Explicit"
 Print #intFile, ""
 Print #intFile, "'Last update: 2002/02/08"
 Print #intFile, "Private Const ERRBASE As Long = -2147217656"
 Print #intFile, "Private mysnInProcessMode As Boolean"
 Print #intFile, ""
 Print #intFile, "Private Sub Class_Terminate()"
 Print #intFile, " deleteTextFile"
 Print #intFile, "End Sub"
 Print #intFile, ""
 Print #intFile, "Private Sub deleteTextFile(ByVal strFile As String)"
 Print #intFile, " If Len(Dir$(strFile)) > 0 Then Kill strFile"
 Print #intFile, "End Sub"
 Print #intFile, ""
 Close intFile
 While FileLen(mstrFile) < 20
      DoEvents
 Wend
End Sub

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 mobjTest.construct mstrFile
 ysnCorrect = True 'No error raised
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestCount_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestCount_onTest
 ysnCorrect = (mobjTest.count = 2)
 Exit Sub
Err_mobjTestCount_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestItem_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestItem_onTest
 ysnCorrect = (TypeName(mobjTest.item(1)) = "ClsVbProcedure")
 Exit Sub
Err_mobjTestItem_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxComplexity_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxComplexity_onTest
 ysnCorrect = (mobjTest.maxComplexity = 1)
 Exit Sub
Err_mobjTestMaxComplexity_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxLinesOfCode_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxLinesOfCode_onTest
 ysnCorrect = (mobjTest.maxLinesOfCode = 3)
 Exit Sub
Err_mobjTestMaxLinesOfCode_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxNumberOfParameters_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxNumberOfParameters_onTest
 ysnCorrect = (mobjTest.maxNumberOfParameters = 1)
 Exit Sub
Err_mobjTestMaxNumberOfParameters_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestName_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestName_onTest
 ysnCorrect = (mobjTest.name = "vbModule")
 Exit Sub
Err_mobjTestName_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsVbModule"
 ysnResult = mobjTestConstructor.runTest("construct")
 ysnResult = ysnResult And mobjTestCount.runTest("count")
 ysnResult = ysnResult And mobjTestItem.runTest("item")
 ysnResult = ysnResult And mobjTestMaxComplexity.runTest("maxComplexity")
 ysnResult = ysnResult And mobjTestMaxLinesOfCode.runTest("maxLinesOfCode")
 ysnResult = ysnResult And mobjTestMaxNumberOfParameters.runTest("maxNumberOfParameters")
 ysnResult = ysnResult And mobjTestName.runTest("name")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
