VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsVbProcedure"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'last update: 2002/04/20
Implements IfcUnitTest

Private mobjTest As New ClsVbProcedure
Private WithEvents mobjTestAddLine As ClsMethodTest
Attribute mobjTestAddLine.VB_VarHelpID = -1
Private WithEvents mobjTestBreakLinkWithParent As ClsMethodTest
Attribute mobjTestBreakLinkWithParent.VB_VarHelpID = -1
Private WithEvents mobjTestComplexity As ClsMethodTest
Attribute mobjTestComplexity.VB_VarHelpID = -1
Private WithEvents mobjTestConstructor As ClsMethodTest
Attribute mobjTestConstructor.VB_VarHelpID = -1
Private WithEvents mobjTestLinesOfCode As ClsMethodTest
Attribute mobjTestLinesOfCode.VB_VarHelpID = -1
Private WithEvents mobjTestName As ClsMethodTest
Attribute mobjTestName.VB_VarHelpID = -1
Private WithEvents mobjTestNumberOfParameters As ClsMethodTest
Attribute mobjTestNumberOfParameters.VB_VarHelpID = -1
Private WithEvents mobjTestParent As ClsMethodTest
Attribute mobjTestParent.VB_VarHelpID = -1

Private Sub Class_Initialize()
 Set mobjTestAddLine = New ClsMethodTest
 Set mobjTestBreakLinkWithParent = New ClsMethodTest
 Set mobjTestComplexity = New ClsMethodTest
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestLinesOfCode = New ClsMethodTest
 Set mobjTestName = New ClsMethodTest
 Set mobjTestNumberOfParameters = New ClsMethodTest
 Set mobjTestParent = New ClsMethodTest
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub mobjTestAddLine_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestAddLine_onTest
 mobjTest.addLine " 'Comment lines should not be counted"
 mobjTest.addLine "#If WHATEVER"
 mobjTest.addLine " somevar=1'Only if WHATEVER is defined in project"
 mobjTest.addLine "#ENDIF"
 mobjTest.addLine " Dim intPos As Integer"
 mobjTest.addLine " intPos = InStr(1, strStatement, ""'"", vbTextCompare)"
 mobjTest.addLine " If intPos > 0 Then strStatement = Left$(strStatement, intPos - 1)"
 mobjTest.addLine ""
 mobjTest.addLine " While intPos > 0"
 mobjTest.addLine "      DoEvents"
 mobjTest.addLine "      intPos = InStr(1, UCase$(strLine), strWord, vbTextCompare)"
 mobjTest.addLine "      If intPos > 0 Then"
 mobjTest.addLine "        If intPos = 1 Then"
 mobjTest.addLine "          ysnBarrierFree = True"
 mobjTest.addLine "        ElseIf intPos = 1 Then"
 mobjTest.addLine "          ysnBarrierFree = True"
 mobjTest.addLine "        Else"
 mobjTest.addLine "          ysnBarrierFree = Not isAlpha(Mid$(strLine, intPos - 1, 1))"
 mobjTest.addLine "        End If"
 mobjTest.addLine "        If ysnBarrierFree Then ysnBarrierFree = Not isAlpha(Mid$(strLine, intPos + Len(strWord), 1))"
 mobjTest.addLine "        If ysnBarrierFree Then"
 mobjTest.addLine "          strLine = Left$(strLine, intPos - 1) & Mid$(strLine, intPos + Len(strWord))"
 mobjTest.addLine "          intPos = 0"
 mobjTest.addLine "          oneIfCouldBeCutFrom = 1"
 mobjTest.addLine "        Else"
 mobjTest.addLine "          intPos = InStr(intPos + 1, UCase$(strLine), strWord, vbTextCompare)"
 mobjTest.addLine "        End If"
 mobjTest.addLine "      End If"
 mobjTest.addLine " Wend"
 mobjTest.addLine " Debug.Print Format$(Now) 'This is where it went wrong"
 ysnCorrect = True 'No error raised
 Exit Sub
Err_mobjTestAddLine_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestBreakLinkWithParent_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestBreakLinkWithParent_onTest
 mobjTest.breakLinkWithParent
 ysnCorrect = True
 Exit Sub
Err_mobjTestBreakLinkWithParent_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestComplexity_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestComplexity_onTest
 ysnCorrect = (mobjTest.complexity = 7)
 Exit Sub
Err_mobjTestComplexity_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 mobjTest.construct "Private Function oneIfCouldBeCutFrom(ByRef strLine As String, ByVal strWord As String) As Byte", New ClsVbModule
 ysnCorrect = (lngError = 0) 'No error raised
 mobjTest.construct "Private Function oneIfCouldBeCutFrom(ByRef strLine As String, ByVal strWord As String) As Byte", New ClsVbModule
 ysnCorrect = ysnCorrect And (lngError = -2147206199) 'Already constructed
 lngError = 0
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestLinesOfCode_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestLinesOfCode_onTest
 ysnCorrect = (mobjTest.linesOfCode = 30)
 Exit Sub
Err_mobjTestLinesOfCode_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestName_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestName_onTest
 ysnCorrect = (mobjTest.name = "oneIfCouldBeCutFrom")
 Exit Sub
Err_mobjTestName_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestNumberOfParameters_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestNumberOfParameters_onTest
 ysnCorrect = (mobjTest.numberOfParameters = 2)
 Exit Sub
Err_mobjTestNumberOfParameters_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestParent_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestParent_onTest
 ysnCorrect = (TypeName(mobjTest.parent) = "ClsVbModule")
 Exit Sub
Err_mobjTestParent_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsVbProcedure"
 ysnResult = mobjTestConstructor.runTest("construct")
 ysnResult = ysnResult And mobjTestAddLine.runTest("addLine")
 ysnResult = ysnResult And mobjTestComplexity.runTest("complexity")
 ysnResult = ysnResult And mobjTestLinesOfCode.runTest("linesOfCode")
 ysnResult = ysnResult And mobjTestName.runTest("name")
 ysnResult = ysnResult And mobjTestNumberOfParameters.runTest("numberOfParameters")
 ysnResult = ysnResult And mobjTestParent.runTest("parent")
 ysnResult = ysnResult And mobjTestBreakLinkWithParent.runTest("breakLinkWithParent")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
