VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsVbProject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'last update: 2002/04/20
Implements IfcUnitTest

Private mobjTest As New ClsVbProject
Private mstrProjectFile As String
Private mstrClassFile As String
Private mstrModuleFile As String
Private WithEvents mobjTestConstructor As ClsMethodTest
Private WithEvents mobjTestCount As ClsMethodTest
Attribute mobjTestCount.VB_VarHelpID = -1
Private WithEvents mobjTestItem As ClsMethodTest
Attribute mobjTestItem.VB_VarHelpID = -1
Private WithEvents mobjTestMaxComplexity As ClsMethodTest
Attribute mobjTestMaxComplexity.VB_VarHelpID = -1
Private WithEvents mobjTestMaxLinesOfCode As ClsMethodTest
Attribute mobjTestMaxLinesOfCode.VB_VarHelpID = -1
Private WithEvents mobjTestMaxNumberOfParameters As ClsMethodTest
Attribute mobjTestMaxNumberOfParameters.VB_VarHelpID = -1
Private WithEvents mobjTestName As ClsMethodTest
Attribute mobjTestName.VB_VarHelpID = -1

Private Sub Class_Initialize()
 mstrProjectFile = gobjUnitTest.GetTempPath & "vbProject.txt"
 mstrClassFile = gobjUnitTest.GetTempPath & "vbProjectClass.cls"
 mstrModuleFile = gobjUnitTest.GetTempPath & "vbProjectModule.bas"
 deleteTextFiles
 makeProjectFile
 makeClassFile
 makeModuleFile
 initializeTests
End Sub

Private Sub Class_Terminate()
 deleteTextFiles
End Sub

Private Sub deleteTextFiles()
 If Len(Dir$(mstrProjectFile)) > 0 Then Kill mstrProjectFile
 If Len(Dir$(mstrClassFile)) > 0 Then Kill mstrClassFile
 If Len(Dir$(mstrModuleFile)) > 0 Then Kill mstrModuleFile
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestCount = New ClsMethodTest
 Set mobjTestItem = New ClsMethodTest
 Set mobjTestMaxComplexity = New ClsMethodTest
 Set mobjTestMaxLinesOfCode = New ClsMethodTest
 Set mobjTestMaxNumberOfParameters = New ClsMethodTest
 Set mobjTestName = New ClsMethodTest
End Sub

Private Sub makeClassFile()
 Dim intFile As Integer
 intFile = FreeFile
 Open mstrClassFile For Output As intFile
 Print #intFile, "VERSION 1.0 CLASS"
 Print #intFile, "BEGIN"
 Print #intFile, "  MultiUse = -1  'True"
 Print #intFile, "  MTSTransactionMode  = 0  'NotAnMTSObject"
 Print #intFile, "END"
 Print #intFile, "Attribute VB_GlobalNameSpace = False"
 Print #intFile, "Attribute VB_Creatable = False"
 Print #intFile, ""
 Print #intFile, "Option Compare Binary"
 Print #intFile, "Option Explicit"
 Print #intFile, ""
 Print #intFile, "'Last update: 2002/02/08"
 Print #intFile, "Private Const ERRBASE As Long = -2147217656"
 Print #intFile, "Private mysnInProcessMode As Boolean"
 Print #intFile, ""
 Print #intFile, "Private Sub Class_Terminate()"
 Print #intFile, " deleteTextFiles"
 Print #intFile, "End Sub"
 Print #intFile, ""
 Print #intFile, "Private Sub deleteTextFiles(ByVal strFile As String)"
 Print #intFile, " If Len(Dir$(strFile)) > 0 Then Kill strFile"
 Print #intFile, "End Sub"
 Print #intFile, ""
 Close intFile
 While FileLen(mstrClassFile) < 20
      DoEvents
 Wend
End Sub

Private Sub makeProjectFile()
 Dim intFile As Integer
 intFile = FreeFile
 Open mstrProjectFile For Output As intFile
 Print #intFile, "Type=Exe"
 Print #intFile, "Reference=*\G{00020430-0000-0000-C000-000000000046}#2.0#0#..\..\..\..\WINDOWS\SYSTEM\STDOLE2.TLB#OLE Automation"
 Print #intFile, "Class=vbProjectClass; vbProjectClass.cls"
 Print #intFile, "Module=vbProjectModule; vbProjectModule.bas"
 Print #intFile, "Startup=""frmMain"""
 Print #intFile, "ExeName32=""OHNO.exe"""
 Print #intFile, "MajorVer=1"
 Print #intFile, "MinorVer=0"
 Close intFile
 While FileLen(mstrProjectFile) < 20
      DoEvents
 Wend
End Sub

Private Sub makeModuleFile()
 Dim intFile As Integer
 intFile = FreeFile
 Open mstrModuleFile For Output As intFile
 Print #intFile, "Option Explicit"
 Print #intFile, "'last update: 2002/02/08"
 Print #intFile, ""
 Print #intFile, "Public gobjErrorLog As New ClsErrorLog"
 Print #intFile, ""
 Print #intFile, "Public Function fracToColour(ByVal dblFrac As Double) As Long"
 Print #intFile, " Dim bytRed As Byte"
 Print #intFile, " Dim bytGreen As Byte"
 Print #intFile, " Dim bytBlue As Byte"
 Print #intFile, " If dblFrac > 1 Or dblFrac < 0 Then Err.Raise 6, ""basGlobal fracToColour"""
 Print #intFile, " If dblFrac > 0.5 Then"
 Print #intFile, "   bytRed = colourComponentOf(1 - dblFrac)"
 Print #intFile, " Else"
 Print #intFile, "   bytRed = colourComponentOf(dblFrac)"
 Print #intFile, " End If"
 Print #intFile, " bytGreen = colourComponentOf(dblFrac - 1# / 3#)"
 Print #intFile, " bytBlue = colourComponentOf(dblFrac - 2# / 3#)"
 Print #intFile, " fracToColour = RGB(bytRed, bytGreen, bytBlue)"
 Print #intFile, "End Function"
 Print #intFile, ""
 Print #intFile, "Private Function colourComponentOf(ByVal dblFrac As Double) As Byte"
 Print #intFile, " dblFrac = Abs(dblFrac)"
 Print #intFile, " If dblFrac < 1# / 3# Then"
 Print #intFile, "   If dblFrac <= 1# / 6# Then"
 Print #intFile, "     colourComponentOf = 255"
 Print #intFile, "   Else"
 Print #intFile, "     colourComponentOf = 255 * (2 - dblFrac * 6)"
 Print #intFile, "   End If"
 Print #intFile, " Else"
 Print #intFile, "   colourComponentOf = 0"
 Print #intFile, " End If"
 Print #intFile, "End Function"
 Close intFile
 While FileLen(mstrModuleFile) < 20
      DoEvents
 Wend
End Sub

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 mobjTest.construct mstrProjectFile
 ysnCorrect = True 'No error raised
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestCount_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestCount_onTest
 ysnCorrect = (mobjTest.count = 2)
 Exit Sub
Err_mobjTestCount_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestItem_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestItem_onTest
 ysnCorrect = (TypeName(mobjTest.item(1)) = "ClsVbModule")
 Exit Sub
Err_mobjTestItem_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxComplexity_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxComplexity_onTest
 ysnCorrect = (mobjTest.maxComplexity = 2)
 Exit Sub
Err_mobjTestMaxComplexity_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxLinesOfCode_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxLinesOfCode_onTest
 ysnCorrect = (mobjTest.maxLinesOfCode = 14)
 Exit Sub
Err_mobjTestMaxLinesOfCode_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestMaxNumberOfParameters_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestMaxNumberOfParameters_onTest
 ysnCorrect = (mobjTest.maxNumberOfParameters = 1)
 Exit Sub
Err_mobjTestMaxNumberOfParameters_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestName_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestName_onTest
 ysnCorrect = (mobjTest.name = "vbProject")
 Exit Sub
Err_mobjTestName_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsVbProject"
 ysnResult = mobjTestConstructor.runTest("construct")
 ysnResult = ysnResult And mobjTestCount.runTest("count")
 ysnResult = ysnResult And mobjTestItem.runTest("item")
 ysnResult = ysnResult And mobjTestMaxComplexity.runTest("maxComplexity")
 ysnResult = ysnResult And mobjTestMaxLinesOfCode.runTest("maxLinesOfCode")
 ysnResult = ysnResult And mobjTestMaxNumberOfParameters.runTest("maxNumberOfParameters")
 ysnResult = ysnResult And mobjTestName.runTest("name")
 Set mobjTest = Nothing
 runUnitTests = ysnResult
End Function
