VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTest_ClsVector2d"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'last update: 2002/04/27
Implements IfcUnitTest

Private WithEvents mobjTestConstructor As ClsMethodTest
Attribute mobjTestConstructor.VB_VarHelpID = -1
Private WithEvents mobjTestLengthOf As ClsMethodTest
Attribute mobjTestLengthOf.VB_VarHelpID = -1
Private WithEvents mobjTestPolarFrom As ClsMethodTest
Attribute mobjTestPolarFrom.VB_VarHelpID = -1
Private WithEvents mobjTestSubstract As ClsMethodTest
Attribute mobjTestSubstract.VB_VarHelpID = -1
Private WithEvents mobjTestX As ClsMethodTest
Attribute mobjTestX.VB_VarHelpID = -1
Private WithEvents mobjTestY As ClsMethodTest
Attribute mobjTestY.VB_VarHelpID = -1

Private Sub Class_Initialize()
 initializeTests
End Sub

Private Function IfcUnitTest_runUnitTests() As Boolean
 IfcUnitTest_runUnitTests = Me.runUnitTests
End Function

Private Sub initializeTests()
 Set mobjTestConstructor = New ClsMethodTest
 Set mobjTestLengthOf = New ClsMethodTest
 Set mobjTestPolarFrom = New ClsMethodTest
 Set mobjTestSubstract = New ClsMethodTest
 Set mobjTestX = New ClsMethodTest
 Set mobjTestY = New ClsMethodTest
End Sub

Private Sub mobjTestConstructor_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestConstructor_onTest
 With New ClsVector2d
     .construct 1.2, 5.6
     ysnCorrect = (lngError = 0)
     .construct 4.5, 3.6
 End With
 ysnCorrect = (lngError = -2147206059)
 lngError = 0
 Exit Sub
Err_mobjTestConstructor_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestLengthOf_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestLengthOf_onTest
 With New ClsVector2d
     .construct 1.5, 2
     ysnCorrect = (.lengthOf = 2.5)
 End With
 Exit Sub
Err_mobjTestLengthOf_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestPolarFrom_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestPolarFrom_onTest
 Const PI As Single = 3.14159265358979 ' 4 * Atn(1)
 Dim objResult As New ClsVector2d
 With New ClsVector2d
     .construct -5.2, 15.4
     Set objResult = .polarFrom(0.75 * PI, Sqr(2))
     ysnCorrect = (objResult.X = -6.2) And (objResult.Y = 16.4)
 End With
 Set objResult = Nothing
 Exit Sub
Err_mobjTestPolarFrom_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestSubstract_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestSubstract_onTest
 Dim objDifference As New ClsVector2d
 Dim objResult As New ClsVector2d
 objDifference.construct 1.45, -3.33
 With New ClsVector2d
     .construct 6.29, 10.78
     Set objResult = .substract(objDifference)
     ysnCorrect = (objResult.X = 4.84) And (objResult.Y = 14.11)
 End With
 Set objResult = Nothing
 Set objDifference = Nothing
 Exit Sub
Err_mobjTestSubstract_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestX_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestX_onTest
 With New ClsVector2d
     .construct -2.75, 2.2
     ysnCorrect = (.X = -2.75)
 End With
 Exit Sub
Err_mobjTestX_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Private Sub mobjTestY_onTest(ByVal strName As String, lngError As Long, ysnCorrect As Boolean)
 On Error GoTo Err_mobjTestY_onTest
 With New ClsVector2d
     .construct 1.5, 2.83
     ysnCorrect = (.Y = 2.83)
 End With
 Exit Sub
Err_mobjTestY_onTest:
 lngError = Err.Number
 Resume Next
End Sub

Public Function runUnitTests() As Boolean
 Dim ysnResult As Boolean
 ysnResult = False
 gobjUnitTest.printStartOfClass "ClsVector2d"
 ysnResult = mobjTestConstructor.runTest("construct")
 ysnResult = ysnResult And mobjTestLengthOf.runTest("lengthOf")
 ysnResult = ysnResult And mobjTestPolarFrom.runTest("polarFrom")
 ysnResult = ysnResult And mobjTestSubstract.runTest("substract")
 ysnResult = ysnResult And mobjTestX.runTest("X")
 ysnResult = ysnResult And mobjTestY.runTest("Y")
 runUnitTests = ysnResult
End Function
