VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsTextFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'Last update: 2001/12/02

Private Const ERRBASE As Long = -2147207854
Private strTextBuffer() As String
Private intLinePointer As Integer
Private strFileName As String
Private strContinuationSequence As String
Private strCommentCharacter As String
Private strNextChr As String

Private Sub checkIndex(ByVal intIdx As Integer)
 If intIdx = 0 Then Err.Raise ERRBASE + 1, "ClsTextFile.lines", "Index out of range. The lines start with one."
 If intIdx > countOfLines Then Err.Raise ERRBASE + 2, "ClsTextFile.lines", "Index out of range. Maximum lines reached."
End Sub

Private Sub Class_Initialize()
 ReDim strTextBuffer(0 To 0)
 strContinuationSequence = "_"
 strCommentCharacter = "'"
End Sub

Public Sub construct(ByVal strPath As String, Optional ByVal ysnMustExist As Boolean = False)
Attribute construct.VB_Description = "Constructor"
 Static ysnHasRunBefore As Boolean
 If ysnHasRunBefore Then
   Err.Raise ERRBASE + 4, "ClsTextFile.construct", "method can only be used once."
 Else
   strFileName = strPath
   If Len(Dir$(strPath)) = 0 Then
     If ysnMustExist Then Err.Raise ERRBASE + 3, "ClsTextFile.construct", "File not """ & strPath & """ found."
   Else
     readBufferFromFile strPath
     If countOfLines > 0 Then resetLinePointer
   End If
 ysnHasRunBefore = True
 End If
End Sub

Private Sub readBufferFromFile(ByRef strPath As String)
 Dim intFile As Integer
 Dim strLine As String
 intFile = FreeFile
 Open strPath For Input As intFile
 While Not EOF(intFile)
      strLine = getTextLine(intFile)
      strTextBuffer(UBound(strTextBuffer)) = strLine
      ReDim Preserve strTextBuffer(0 To UBound(strTextBuffer) + 1)
 Wend
 Close intFile
End Sub

Public Function countOfLines() As Integer
Attribute countOfLines.VB_Description = "Count of text lines in the internal buffer"
 countOfLines = UBound(strTextBuffer)
End Function

Public Function endReached() As Boolean
Attribute endReached.VB_Description = "True if the last line of the buffer has been read"
 endReached = (intLinePointer > countOfLines)
End Function

Public Sub deleteLines(ByVal intLine As Integer, Optional ByVal intNumOfLines As Integer = 1)
Attribute deleteLines.VB_Description = "Delete text lines from the internal buffer"
 Dim intCnt As Integer
 checkIndex intLine
 intCnt = intLine - 1
 While intCnt < intLine + intNumOfLines - 1
      strTextBuffer(intCnt) = strTextBuffer(intCnt + intNumOfLines)
      intCnt = intCnt + 1
 Wend
 If intLinePointer >= intLine Then
   If intLinePointer <= intLine + intNumOfLines Then
     intLinePointer = 0
   Else
     intLinePointer = intLinePointer - intNumOfLines
   End If
 End If
 ReDim Preserve strTextBuffer(0 To UBound(strTextBuffer) - intNumOfLines)
End Sub

Public Function filename() As String
Attribute filename.VB_Description = "The name of the file this object is a working copy of"
 filename = strFileName
End Function

Public Function findLine(ByVal strContent As String, Optional ByVal intStartWith As Integer = 1) As Integer
 Dim intCnt As Integer
 intCnt = intStartWith - 1
 findLine = 0
 While intCnt < countOfLines
      If InStr(1, strTextBuffer(intCnt), strContent) > 0 Then
        intLinePointer = intCnt + 1
        findLine = intLinePointer
        intCnt = countOfLines + 1
      End If
      intCnt = intCnt + 1
 Wend
End Function

Public Function firstExpandedLine() As String
 resetLinePointer
 firstExpandedLine = nextExpandedLine
End Function

Public Function firstLine() As String
 resetLinePointer
 firstLine = nextLine
End Function

Public Function firstLineOfString(ByVal strLines As String) As String
 Dim intPos As Integer
 firstLineOfString = strLines
 intPos = InStr(1, strLines, vbCrLf, vbBinaryCompare)
 If intPos > 0 Then
   firstLineOfString = Left$(strLines, intPos - 1)
 End If
End Function

Public Function followingLinesOfString(ByVal strLines As String) As String
 Dim intPos As Integer
 followingLinesOfString = ""
 intPos = InStr(1, strLines, vbCrLf, vbBinaryCompare)
 If intPos > 0 Then
   followingLinesOfString = Mid$(strLines, intPos + 2)
 End If
End Function

Private Function getTextLine(ByVal intFile As Integer) As String
 Dim strResult As String
 Dim strCurrentChr As String
 Dim ysnFinished As Boolean
 getTextLine = ""
 strResult = ""
 If strNextChr = vbCr Or strNextChr = vbLf Then
   readNewLine intFile, strNextChr
 Else
   strResult = strNextChr
   strNextChr = ""
   ysnFinished = EOF(intFile)
   While Not ysnFinished
        strCurrentChr = Input(1, intFile)
        If strCurrentChr = vbCr Or strCurrentChr = vbLf Then
          ysnFinished = True
        Else
          strResult = strResult & strCurrentChr
          ysnFinished = EOF(intFile)
        End If
   Wend
   readNewLine intFile, strCurrentChr
 End If
 getTextLine = strResult
End Function

Public Function lines(ByVal intLine As Integer, Optional ByVal intNumOfLines As Integer = 1) As String
Attribute lines.VB_Description = "Returns any line(s) from the internal buffer"
Attribute lines.VB_UserMemId = 0
 Dim strResult As String
 checkIndex intLine
 strResult = strTextBuffer(intLine - 1)
 intLine = intLine + 1
 intNumOfLines = intNumOfLines - 1
 While (intLine <= countOfLines) And (intNumOfLines > 0)
      strResult = strResult & vbCrLf & strTextBuffer(intLine - 1)
      intLine = intLine + 1
      intNumOfLines = intNumOfLines - 1
 Wend
 lines = strResult
 intLinePointer = intLine + intNumOfLines
End Function

Public Function linePointer() As Integer
 linePointer = intLinePointer
End Function

Public Function nextExpandedLine() As String
 Dim strLine As String
 Dim strResult As String
 Dim intLenOfContSeq As Integer
 intLenOfContSeq = Len(strContinuationSequence)
 strResult = nextLine
 strLine = strResult
 While Right$(strLine, intLenOfContSeq) = strContinuationSequence
      strLine = nextLine
      strResult = Left$(strResult, Len(strResult) - intLenOfContSeq) & vbCrLf & strLine
 Wend
 nextExpandedLine = strResult
End Function

Public Function nextLine() As String
 nextLine = lines(intLinePointer, 1)
End Function

Private Sub readNewLine(ByVal intFile As Integer, ByVal strChr As String)
 strNextChr = ""
 If Not EOF(intFile) Then
   If strChr = vbCr Or strChr = vbLf Then
     strNextChr = Input(1, intFile)
     If strChr = vbCr And strNextChr = vbLf Then strNextChr = ""
     If strChr = vbLf And strNextChr = vbCr Then strNextChr = ""
   End If
 End If
End Sub

Public Sub replaceLines(ByVal intLine As Integer, ByVal strNewLine As String, Optional ByVal intNumToReplace As Integer = 1)
 strTextBuffer(intLine) = firstLineOfString(strNewLine)
 strNewLine = followingLinesOfString(strNewLine)
 If intNumToReplace > 1 Then deleteLines intLine + 1, intNumToReplace - 1
 If Len(strNewLine) > 0 Then
   'insertLine
 End If
End Sub

Public Sub replaceOriginal()
 Dim intFile As Integer
 Dim intCnt As Integer
 intFile = FreeFile
 Kill strFileName
 Open strFileName For Output As #intFile
     intCnt = 0
     While intCnt < countOfLines
          Print #intFile, strTextBuffer(intCnt)
          intCnt = intCnt + 1
     Wend
 Close intFile
End Sub

Public Sub resetLinePointer()
Attribute resetLinePointer.VB_Description = "Set the line pointer to the first line of the buffer"
 If countOfLines < 1 Then Err.Raise ERRBASE + 4, "ClsTextFile.resetLinePointer", "No lines in text file."
 intLinePointer = 1
End Sub
