VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsUnitTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Last update: 2002/04/27

Private Const ERRBASE As Long = -2147206788 'UT

Private mobjUnitLog As New ClsErrorLog
Private mstrMethodName As String
Private mstrClassName As String

Private Declare Function apiGetTempPath Lib "kernel32.dll" Alias "GetTempPathA" (ByVal lngBufferLength As Long, ByVal lpBuffer As String) As Long

Private Sub Class_Initialize()
 On Error Resume Next
 gobjErrorLog.construct
 On Error GoTo Err_Class_Initialize
 mobjUnitLog.construct App.Path & "\UNITTEST.LOG"
Exit_Class_Initialize:
 Exit Sub
Err_Class_Initialize:
 gobjErrorLog.logError "ClsUnitTest.Class_Initialize", SILENTMODE_OFF
 Resume Exit_Class_Initialize
End Sub

Private Sub Class_Terminate()
 Set mobjUnitLog = Nothing
End Sub

Public Function GetTempPath() As String
 Const BUFLEN = 254
 Dim strBuffer As String * BUFLEN
 GetTempPath = ""
 If apiGetTempPath(BUFLEN, strBuffer) <> 0 Then
   GetTempPath = Left$(strBuffer, InStr(1, strBuffer, Chr$(0), vbBinaryCompare) - 1)
 End If
End Function

Public Sub printResult(ByVal ysnResult As Boolean)
 Dim strOutput As String
 strOutput = IIf(ysnResult, " OK", " FAILED")
 If Not ysnResult Then Debug.Print
 Debug.Print strOutput
 mobjUnitLog.writeError strOutput & "          " & mstrClassName & "." & mstrMethodName, mstrClassName, SILENTMODE_ON
End Sub

Public Sub printStartOfClass(ByVal strClass As String)
 mstrClassName = strClass
 Debug.Print "      Class """; strClass; """"
 mobjUnitLog.writeError "      Class """ & strClass & """", "ClsUnitTest.runUnitTests", SILENTMODE_ON
End Sub

Public Sub printStartOfMethod(ByVal strMethod As String)
 mstrMethodName = strMethod
 Debug.Print "             "; mstrClassName; "."; strMethod;
End Sub

Private Function runClassTests() As Boolean
'necessary because objects cannot be generated from code
 Dim ysnResult As Boolean
 ysnResult = True 'Nothing failed yet
 runTestForClass New ClsTest_ClsApplicationSettings, ysnResult
 runTestForClass New ClsTest_ClsAssert, ysnResult
 runTestForClass New ClsTest_ClsErrorLog, ysnResult
 runTestForClass New ClsTest_ClsInifile, ysnResult
 runTestForClass New ClsTest_ClsResizer, ysnResult
 runTestForClass New ClsTest_ClsSpotGraph, ysnResult
 runTestForClass New ClsTest_ClsTextFile, ysnResult
 runTestForClass New ClsTest_ClsVbModule, ysnResult
 runTestForClass New ClsTest_ClsVbProcedure, ysnResult
 runTestForClass New ClsTest_ClsVbProcedures, ysnResult
 runTestForClass New ClsTest_ClsVbProject, ysnResult
 runTestForClass New ClsTest_ClsVector2d, ysnResult
 runClassTests = ysnResult
End Function

Private Sub runTestForClass(ByRef objTestClass As IfcUnitTest, ByRef ysnCorrect As Boolean)
 ysnCorrect = ysnCorrect And objTestClass.runUnitTests
End Sub

Public Sub runUnitTests()
 Dim ysnResult As Boolean
 On Error GoTo Err_runUnitTests
 mobjUnitLog.writeError "Start of Unit Tests", "ClsUnitTest.runUnitTests", SILENTMODE_ON
 ysnResult = runClassTests
 Debug.Print "      END of unit tests." & vbCrLf & IIf(ysnResult, "All tests passed.", "Some tests failed.")
 mobjUnitLog.writeError "End of Unit tests. Unit tests ran and " & _
                        IIf(ysnResult, "all tests passed.", "some tests did not pass."), _
                        "ClsUnitTest.runUnitTests", SILENTMODE_ON
Exit_runUnitTests:
 Exit Sub
Err_runUnitTests:
 mobjUnitLog.logError "ClsUnitTest runUnitTests", SILENTMODE_OFF
 Resume Exit_runUnitTests
End Sub
