VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsVbModule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/03/26

Private Const ERRBASE As Long = -2147206294 'VM
'public class ClsVbModule

Private mysnIsConstructed As Boolean
Private mobjVbProcedure() As ClsVbProcedure
Private mobjSource As New ClsTextFile
Private mlngMaxLinesOfCode As Long
Private mlngMaxComplexity As Long
Private mbytMaxNumberOfParameters As Byte
Private mstrName As String

Private Sub add(ByRef objProcedure As ClsVbProcedure)
 Dim lngCount As Long
 lngCount = count
 Set mobjVbProcedure(lngCount) = objProcedure
 ReDim Preserve mobjVbProcedure(0 To lngCount + 1)
 With objProcedure
     If .complexity > mlngMaxComplexity Then mlngMaxComplexity = .complexity
     If .linesOfCode > mlngMaxLinesOfCode Then mlngMaxLinesOfCode = .linesOfCode
     If .numberOfParameters > mbytMaxNumberOfParameters Then mbytMaxNumberOfParameters = .numberOfParameters
 End With
End Sub

Private Sub checkIfConstructed()
 If Not mysnIsConstructed Then Err.Raise ERRBASE + 5, "Please construct this poor little ClsVbModule object first."
End Sub

Private Sub Class_Initialize()
 ReDim mobjVbProcedure(0 To 0)
End Sub

Private Sub Class_Terminate()
 clear
End Sub

Public Sub clear()
 Dim lngCount As Long
 lngCount = count - 1
 While lngCount >= 0
      mobjVbProcedure(lngCount).breakLinkWithParent
      Set mobjVbProcedure(lngCount) = Nothing
      lngCount = lngCount - 1
 Wend
 ReDim mobjVbProcedure(0 To 0)
 Set mobjSource = Nothing
End Sub

Public Sub construct(ByRef strFile As String)
 If mysnIsConstructed Then
   Err.Raise ERRBASE + 1, "ClsVbModule.construct", "Construct method can only be used once."
 Else
   If Len(strFile) = 0 Then Err.Raise ERRBASE + 2, "ClsVbModule.construct", "File cannot be an empty string."
   If Len(Dir$(strFile)) = 0 Then Err.Raise ERRBASE + 2, "ClsVbModule.construct", "File """ & strFile & """ not found."
   mobjSource.construct strFile, True
   mstrName = nameOf(strFile)
   parse
   mysnIsConstructed = True
 End If
End Sub

Public Function count() As Long
 count = UBound(mobjVbProcedure)
End Function

Private Sub deleteStringLiterals(ByRef strLine As String)
 Dim intStartPos As Integer
 Dim intEndPos As Integer
 intStartPos = InStr(1, strLine, """", vbBinaryCompare)
 While intStartPos > 0
      intEndPos = InStr(intStartPos + 1, strLine, """", vbBinaryCompare)
      If intEndPos > 0 Then
        strLine = Left$(strLine, intStartPos) & Mid$(strLine, intEndPos)
      End If
      intStartPos = InStr(intStartPos + 2, strLine, """", vbBinaryCompare)
 Wend
End Sub

Private Function hasWordInIt(ByVal strSearched As String, ByVal strWord As String) As Boolean
'Returns true if the string is found as a whole word (surrounded by spaces or string ends)
 Dim ysnResult As Boolean
 strSearched = UCase$(strSearched)
 strWord = UCase$(strWord)
 ysnResult = (strSearched = strWord)
 If Not ysnResult Then
   ysnResult = (Left$(strSearched, Len(strWord) + 1) = strWord & " ")
   If Not ysnResult Then
     ysnResult = (InStr(1, strSearched, " " & strWord & " ", vbBinaryCompare) > 0)
     If Not ysnResult Then ysnResult = (Right$(strSearched, Len(strWord) + 1) = " " & strWord)
   End If
 End If
 hasWordInIt = ysnResult
End Function

Public Function item(ByVal lngIndex As Long) As ClsVbProcedure
Attribute item.VB_Description = "Procedure within Module"
Attribute item.VB_UserMemId = 0
Attribute item.VB_MemberFlags = "40"
 checkIfConstructed
 If lngIndex > count Then Err.Raise ERRBASE + 4, "ClsVbModule.item", "Item " & lngIndex & " not found in this collection."
 Set item = mobjVbProcedure(lngIndex - 1)
End Function

Public Function maxComplexity() As Long
 checkIfConstructed
 maxComplexity = mlngMaxComplexity
End Function

Public Function maxLinesOfCode() As Long
 checkIfConstructed
 maxLinesOfCode = mlngMaxLinesOfCode
End Function

Public Function maxNumberOfParameters() As Byte
 checkIfConstructed
 maxNumberOfParameters = mbytMaxNumberOfParameters
End Function

Public Function name() As String
 name = mstrName
End Function

Private Function nameOf(ByVal strPath As String) As String
 Dim intPos As Integer
 Dim intLastPos As Integer
 Dim strResult As String
 strPath = Dir$(strPath)
 intLastPos = Len(strPath)
 intPos = InStr(1, strPath, ".", vbBinaryCompare)
 While intPos > 0
      intLastPos = intPos
      intPos = InStr(intPos + 1, strPath, ".", vbBinaryCompare)
 Wend
 strResult = Left$(strPath, intLastPos - 1)
 nameOf = strResult
End Function

Private Sub parse()
 Dim strLine As String
 Dim objProcedure As ClsVbProcedure
 readFirstLineAfterHeader strLine
 readMeaningFulLine strLine, False
 While Not mobjSource.endReached
      While Not mobjSource.endReached And (hasWordInIt(strLine, "declare") Or Not (hasWordInIt(strLine, "sub") Or hasWordInIt(strLine, "function") Or hasWordInIt(strLine, "property")))
           readMeaningFulLine strLine, True
      Wend
      If Not mobjSource.endReached Then
        Set objProcedure = New ClsVbProcedure
        objProcedure.construct strLine, Me
        readMeaningFulLine strLine, True
        While Not mobjSource.endReached And Not (hasWordInIt(strLine, "end sub") Or hasWordInIt(strLine, "end function") Or hasWordInIt(strLine, "end property"))
             objProcedure.addLine strLine
             readMeaningFulLine strLine, True
        Wend
        add objProcedure
        If Not mobjSource.endReached Then readMeaningFulLine strLine, True
      End If
 Wend
 Set objProcedure = Nothing
End Sub

Private Sub readMeaningFulLine(ByRef strLine As String, Optional ByVal ysnNext As Boolean = True)
 Dim ysnMeaningFul As Boolean
 With mobjSource
     If .endReached Then
       strLine = ""
     Else
       If ysnNext Then strLine = .nextExpandedLine
     End If
     ysnMeaningFul = False
     While Not ysnMeaningFul
          ysnMeaningFul = True
          If UCase$(Left$(Trim$(strLine), 10)) = "ATTRIBUTE " Then
            ysnMeaningFul = False
          Else
            deleteStringLiterals strLine
            stripComment strLine
            If Len(Trim$(strLine)) = 0 Then ysnMeaningFul = False
          End If
          If Not ysnMeaningFul Then
            If Not .endReached Then
              strLine = .nextExpandedLine
            Else
              ysnMeaningFul = True
            End If
          End If
     Wend
 End With
End Sub

Private Sub readFirstLineAfterHeader(ByRef strLine As String)
 Dim ysnContinue As Boolean
 Dim intSectionDepth As Integer
 With mobjSource
     strLine = .firstExpandedLine
     If strLine Like "VERSION *.*" Then strLine = .nextExpandedLine
     ysnContinue = True
     intSectionDepth = 0
     While ysnContinue
          If UCase$(Left$(Trim$(strLine), 10)) = "ATTRIBUTE " Then
            strLine = .nextExpandedLine
          ElseIf Len(Trim$(strLine)) = 0 Then
            strLine = .nextExpandedLine
          ElseIf UCase$(Left$(Trim$(strLine), 6)) = "BEGIN " Or UCase$(Trim$(strLine)) = "BEGIN" Then
            intSectionDepth = intSectionDepth + 1
            strLine = .nextExpandedLine
          ElseIf UCase$(Left$(Trim$(strLine), 4)) = "END " Or UCase$(Trim$(strLine)) = "END" Then
            intSectionDepth = intSectionDepth - 1
            strLine = .nextExpandedLine
          ElseIf intSectionDepth > 0 Then
            strLine = .nextExpandedLine
          ElseIf .endReached Then
            Err.Raise ERRBASE + 3, "ClsVbModule.readFirstLineAfterHeader", "End of file reached before end of header."
          Else
            ysnContinue = False
          End If
     Wend
 End With
End Sub

Private Sub stripComment(ByRef strStatement As String)
 Dim intPos As Integer
 intPos = InStr(1, strStatement, "'", vbBinaryCompare)
 If intPos > 0 Then strStatement = Left$(strStatement, intPos - 1)
End Sub

