VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsVbProcedure"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/04/18

'public class ClsVbProcedure
Private Const ERRBASE As Long = -2147206216 + 16 'VP
Public Enum enmScope
    PUBLIC_SCOPE = 1
    FRIEND_SCOPE = 2
    PROTECTED_SCOPE = 3
    PRIVATE_SCOPE = 4
End Enum

Private mstrBodyLine() As String
Private mstrName As String
Private mbytNumberOfParameters As Byte
Private mlngScope As enmScope
Private mlngComplexity As Long
Private mysnIsConstructed As Boolean
Private mlngBodyLineCount As Long
Private mobjParent As ClsVbModule

Public Sub addLine(ByVal strLine As String)
 checkIfConstructed
 deleteStringLiterals strLine 'They might contain keywords...
 stripComment strLine
 strLine = Trim$(strLine)
 If Right$(strLine, 2) = " _" Then Err.Raise ERRBASE + 3, "ClsVbProcedure.addLine", "Half lines do not count. Line continuations not allowed."
 If Len(strLine) > 0 Then
   mlngBodyLineCount = mlngBodyLineCount + 1
   mlngComplexity = mlngComplexity + complexityOf(strLine)
 End If
End Sub

Public Sub breakLinkWithParent()
 Set mobjParent = Nothing
End Sub

Private Sub checkIfConstructed()
 If Not mysnIsConstructed Then Err.Raise ERRBASE, "ClsVbProcedure.construct", "Please construct this poor little object first."
End Sub

Public Function complexity() As Long
 checkIfConstructed
 complexity = mlngComplexity
End Function

Private Function complexityOf(ByRef strWhatOf As String) As Long
'byref for speed.
 Dim lngResult As Long
 Dim lngRoundScore As Long
 lngRoundScore = 1
 removeEndsOfStructures strWhatOf
 While lngRoundScore > 0
      lngRoundScore = oneIfCouldBeCutFrom(strWhatOf, "if")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "while")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "do")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "with")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "select")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "for")
      lngRoundScore = lngRoundScore + oneIfCouldBeCutFrom(strWhatOf, "elseif")
      lngResult = lngResult + lngRoundScore
 Wend
 complexityOf = lngResult
End Function

Public Function construct(ByVal strDeclarationLine As String, ByRef objParent As ClsVbModule)
 If mysnIsConstructed Then
   Err.Raise ERRBASE + 1, "ClsVbProcedure.construct", "Construct method can only be used once."
 Else
   If Len(strDeclarationLine) = 0 Then Err.Raise ERRBASE + 2, "ClsVbProcedure.construct", "Procedure name cannot be an empty string."
   If objParent Is Nothing Then Err.Raise ERRBASE + 2, "ClsVbProcedure.construct", "Parent cannot be an empty object."
   deleteStringLiterals strDeclarationLine
   stripComment strDeclarationLine
   mstrName = functionNameOf(strDeclarationLine)
   mbytNumberOfParameters = parameterCountOf(strDeclarationLine)
   Set mobjParent = objParent
   mysnIsConstructed = True
 End If
End Function

Private Sub deleteStringLiterals(ByRef strLine As String)
 Dim intStartPos As Integer
 Dim intEndPos As Integer
 intStartPos = InStr(1, strLine, """", vbTextCompare)
 While intStartPos > 0
      intEndPos = InStr(intStartPos + 1, strLine, """", vbTextCompare)
      If intEndPos > 0 Then
        strLine = Left$(strLine, intStartPos) & Mid$(strLine, intEndPos)
      End If
      intStartPos = InStr(intStartPos + 2, strLine, """", vbTextCompare)
 Wend
End Sub

Private Function functionNameOf(ByVal strLine As String) As String
 Dim intPos As Integer
 Dim strResult As String
 intPos = InStr(1, strLine, "(", vbTextCompare)
 If intPos < 1 Then Err.Raise ERRBASE + 4, "ClsVbProcedure.functionNameOf", """" & strLine & """ is not a procedure definition."
 strLine = Trim$(Left$(strLine, intPos - 1))
 intPos = InStr(1, strLine, "Property ", vbTextCompare)
 If intPos > 0 Then
   strResult = Mid$(strLine, intPos + 9, 4)
   strLine = Trim$(Mid$(strLine, intPos + 12))
 End If
 intPos = InStr(1, strLine, " ", vbTextCompare)
 While intPos > 0
      strLine = Trim$(Mid$(strLine, intPos + 1))
      intPos = InStr(1, strLine, " ", vbTextCompare)
 Wend
 functionNameOf = strResult & strLine
End Function

Private Function isAlpha(ByRef strWhat As String) As Boolean
 isAlpha = (strWhat = "#") Or (("A" <= strWhat) And (strWhat <= "Z"))
End Function

Public Function linesOfCode() As Long
 checkIfConstructed
 linesOfCode = mlngBodyLineCount + 2 'Header + end function
End Function

Public Function name() As String
 name = mstrName
End Function

Public Function numberOfParameters() As Byte
 checkIfConstructed
 numberOfParameters = mbytNumberOfParameters
End Function

Private Function oneIfCouldBeCutFrom(ByRef strLine As String, ByRef strWord As String) As Byte
 Dim intPos As Integer
 Dim ysnBarrierFree As Boolean
 strWord = UCase$(strWord)
 strLine = UCase$(strLine)
 intPos = InStr(1, strLine, strWord, vbBinaryCompare)
 While intPos > 0
      If intPos = 1 Then
        ysnBarrierFree = True
      Else
        ysnBarrierFree = Not isAlpha(Mid$(strLine, intPos - 1, 1))
      End If
      If ysnBarrierFree Then ysnBarrierFree = Not isAlpha(Mid$(strLine, intPos + Len(strWord), 1))
      If ysnBarrierFree Then
        strLine = Left$(strLine, intPos - 1) & Mid$(strLine, intPos + Len(strWord))
        intPos = 0
        oneIfCouldBeCutFrom = 1
      Else
        intPos = InStr(intPos + 1, strLine, strWord, vbBinaryCompare)
      End If
 Wend
End Function

Private Function parameterCountOf(ByVal strLine As String) As Byte
 Dim intPos As Integer
 Dim intLastPos As Integer
 Dim bytResult As Byte
 intPos = InStr(1, strLine, "(", vbTextCompare)
 strLine = Trim$((Mid$(strLine, intPos + 1)))
 intPos = InStr(1, strLine, ")", vbTextCompare)
 intLastPos = intPos
 intPos = InStr(intPos + 1, strLine, ")", vbTextCompare)
 While intPos > 0
      intLastPos = intPos
      intPos = InStr(intPos + 1, strLine, ")", vbTextCompare)
 Wend
 strLine = Left$(strLine, intLastPos - 1)
 If Len(strLine) > 0 Then bytResult = 1
 intPos = InStr(1, strLine, ",", vbTextCompare)
 While intPos > 0
      bytResult = bytResult + 1
      intPos = InStr(intPos + 1, strLine, ",", vbTextCompare)
 Wend
 parameterCountOf = bytResult
End Function

Public Function parent() As ClsVbModule
 checkIfConstructed
 If mobjParent Is Nothing Then Err.Raise ERRBASE + 5, "ClsVbProcedure.parent", "Parent must be set."
 Set parent = mobjParent
End Function

Private Sub removeEndsOfStructures(ByRef strLine As String)
'Just cut "End If" ect. from the code
 While oneIfCouldBeCutFrom(strLine, "end if") > 0: Wend
 While oneIfCouldBeCutFrom(strLine, "end do") > 0: Wend
 While oneIfCouldBeCutFrom(strLine, "end with") > 0: Wend
 While oneIfCouldBeCutFrom(strLine, "end select") > 0: Wend
End Sub

Private Sub stripComment(ByRef strStatement As String)
 Dim intPos As Integer
 intPos = InStr(1, strStatement, "'", vbTextCompare)
 If intPos > 0 Then strStatement = Left$(strStatement, intPos - 1)
End Sub
