VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsVbProcedures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/04/18

Private Const ERRBASE As Long = -2147206216 'VP
'public class ClsVbProcedures

Private mlngId() As Long
Private mobjProcedure() As ClsVbProcedure
Private mysnIsSorted As Boolean
Private mlngMaxComplexity As Long
Private mlngMaxLinesOfCode As Long
Private msngDistance() As Single

Public Sub add(ByRef objProcedure As ClsVbProcedure, ByVal lngId As Long)
 Dim lngCount As Long
 If Not positionOf(lngId) < 0 Then Err.Raise ERRBASE + 2, "ClsVbProcedures.add", "Item already exist in this collection"
 If mysnIsSorted Then Err.Raise ERRBASE + 3, "ClsVbProcedures.add", "Invalid call if sorted"
 lngCount = count
 Set mobjProcedure(lngCount) = objProcedure
 mlngId(lngCount) = lngId
 lngCount = lngCount + 1
 ReDim Preserve mobjProcedure(0 To lngCount)
 ReDim Preserve mlngId(0 To lngCount)
End Sub

Private Sub calculateDistances()
 Dim lngCount As Long
 Dim sngLinesOfCode As Single
 Dim sngComplexity As Single
 lngCount = count - 1
 ReDim msngDistance(0 To count)
 While lngCount >= 0
      With mobjProcedure(lngCount)
          sngLinesOfCode = .linesOfCode / mlngMaxLinesOfCode
          sngComplexity = .complexity / mlngMaxComplexity
      End With
      msngDistance(lngCount) = sngLinesOfCode * sngLinesOfCode + sngComplexity * sngComplexity
      lngCount = lngCount - 1
 Wend
End Sub

Private Sub Class_Initialize()
 ReDim mlngId(0 To 0)
 ReDim mobjProcedure(0 To 0)
 ReDim msngDistance(0 To 0)
End Sub

Private Sub Class_Terminate()
 Dim lngCount As Long
 lngCount = count - 1
 While lngCount >= 0
      Set mobjProcedure(lngCount) = Nothing
      lngCount = lngCount - 1
 Wend
 ReDim mobjProcedure(0 To 0)
End Sub

Public Function count() As Long
 count = UBound(mobjProcedure)
End Function

Private Sub determineMaxima()
 Dim lngCount As Long
 lngCount = count - 1
 While lngCount >= 0
      With mobjProcedure(lngCount)
          If .linesOfCode > mlngMaxLinesOfCode Then mlngMaxLinesOfCode = .linesOfCode
          If .complexity > mlngMaxComplexity Then mlngMaxComplexity = .complexity
      End With
      lngCount = lngCount - 1
 Wend
End Sub

Public Function IdOf(ByVal lngWhich As Long) As Long
 If lngWhich > count Then Err.Raise ERRBASE + 4, "ClsVbProcedures.IdOf", "Procedure must exist"
 IdOf = mlngId(lngWhich - 1)
End Function

Private Function isFurtherOrBigger(ByVal lngThis As Long, ByVal lngThan As Long) As Boolean
 If msngDistance(lngThis) = msngDistance(lngThan) Then
   isFurtherOrBigger = (mobjProcedure(lngThis).numberOfParameters > mobjProcedure(lngThan).numberOfParameters)
 Else
   isFurtherOrBigger = (msngDistance(lngThis) > msngDistance(lngThan))
 End If
End Function

Public Function isSorted() As Boolean
 isSorted = mysnIsSorted
End Function

Public Function item(ByVal lngWhich As Long) As ClsVbProcedure
 If lngWhich > count Then Err.Raise ERRBASE + 4, "ClsVbProcedures.IdOf", "Procedure must exist"
 Set item = mobjProcedure(lngWhich - 1)
End Function

Public Function itemById(ByVal lngId As Long) As ClsVbProcedure
 If positionOf(lngId) < 0 Then Err.Raise ERRBASE + 4, "ClsVbProcedures.itemById", "Procedure must exist"
 Set itemById = mobjProcedure(positionOf(lngId))
End Function

Private Function positionOf(ByVal lngId As Long) As Long
 Dim lngCount As Long
 lngCount = count - 1
 positionOf = -1
 While lngCount >= 0
      If mlngId(lngCount) = lngId Then
        positionOf = lngCount
        lngCount = -1
      End If
      lngCount = lngCount - 1
 Wend
End Function

Public Sub sortByDistance()
 If mysnIsSorted Then Err.Raise ERRBASE + 5, "ClsVbProcedures.sortByDistance", "Collection is already sorted."
 determineMaxima
 calculateDistances
 sortProcedures
 ReDim msngDistance(0 To 0)
 mysnIsSorted = True
End Sub

Private Sub sortProcedures()
'bubbleSort. Furthest and biggest go first.
 Dim lngLowerBound As Long
 Dim lngUpperBound As Long
 lngLowerBound = 0
 lngUpperBound = count - 2
 While lngLowerBound <= lngUpperBound
      bubbleUp lngLowerBound, lngUpperBound
      lngUpperBound = lngUpperBound - 1
      bubbleDown lngLowerBound, lngUpperBound
      lngLowerBound = lngLowerBound + 1
 Wend
End Sub

Private Sub bubbleDown(ByVal lngLower As Long, ByVal lngUpper As Long)
 Dim lngCount As Long
 lngCount = lngUpper
 While lngCount >= lngLower
      If isFurtherOrBigger(lngCount + 1, lngCount) Then swapWithNext lngCount
      lngCount = lngCount - 1
 Wend
End Sub

Private Sub bubbleUp(ByVal lngLower As Long, ByVal lngUpper As Long)
 Dim lngCount As Long
 lngCount = lngLower
 While lngCount <= lngUpper
      If isFurtherOrBigger(lngCount + 1, lngCount) Then swapWithNext lngCount
      lngCount = lngCount + 1
 Wend
End Sub

Private Sub swapWithNext(ByVal lngPosition As Long)
 Dim objProc As ClsVbProcedure
 Dim lngId As Long
 Dim sngDistance As Single
 Set objProc = mobjProcedure(lngPosition)
 lngId = mlngId(lngPosition)
 sngDistance = msngDistance(lngPosition)
 Set mobjProcedure(lngPosition) = mobjProcedure(lngPosition + 1)
 mlngId(lngPosition) = mlngId(lngPosition + 1)
 msngDistance(lngPosition) = msngDistance(lngPosition + 1)
 Set mobjProcedure(lngPosition + 1) = objProc
 mlngId(lngPosition + 1) = lngId
 msngDistance(lngPosition + 1) = sngDistance
End Sub
