VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsVbProject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'last update: 2002/04/05

Private Const ERRBASE As Long = -2147206216 'VP
'public class ClsVbProject

Private mobjVbModule() As ClsVbModule
Private mobjTextFile As ClsTextFile
Private mlngMaxLinesOfCode As Long
Private mlngMaxComplexity As Long
Private mbytMaxNumberOfParameters As Byte
Private mstrName As String
Private mstrPath As String

Private Sub add(ByRef strFile As String)
 Dim lngCount As Long
 Dim objModule As New ClsVbModule
 lngCount = count
 With objModule
     .construct strFile
     If .maxComplexity > mlngMaxComplexity Then mlngMaxComplexity = .maxComplexity
     If .maxLinesOfCode > mlngMaxLinesOfCode Then mlngMaxLinesOfCode = .maxLinesOfCode
     If .maxNumberOfParameters > mbytMaxNumberOfParameters Then mbytMaxNumberOfParameters = .maxNumberOfParameters
 End With
 Set mobjVbModule(lngCount) = objModule
 ReDim Preserve mobjVbModule(0 To lngCount + 1)
End Sub

Private Sub Class_Initialize()
 ReDim mobjVbModule(0 To 0)
End Sub

Private Sub Class_Terminate()
 Dim lngCount As Long
 lngCount = count - 1
 While lngCount >= 0
      mobjVbModule(lngCount).clear
      Set mobjVbModule(lngCount) = Nothing
      lngCount = lngCount - 1
 Wend
 Set mobjTextFile = Nothing
End Sub

Public Sub construct(ByVal strFile As String)
 Const ERR_FILE_NOT_FOUND As Long = 53
 Static ysnHasRunbefore As Boolean
 If ysnHasRunbefore Then
   Err.Raise ERRBASE + 1, "ClsVbProject.construct", "Construct method can only be used once."
 Else
   If Len(strFile) = 0 Then Err.Raise ERRBASE + 2, "ClsVbProject.construct", "File cannot be an empty string."
   If Len(Dir$(strFile)) = 0 Then Err.Raise ERR_FILE_NOT_FOUND, "ClsVbProject.construct"
   mstrName = nameOf(strFile)
   extractPath strFile
   parse strFile
   ysnHasRunbefore = True
 End If
End Sub

Public Function count() As Long
 count = UBound(mobjVbModule)
End Function

Private Sub extractPath(ByRef strFullPath As String)
 Dim intPos As Integer
 intPos = Len(strFullPath)
 While Mid$(strFullPath, intPos, 1) <> "\"
      intPos = intPos - 1
 Wend
 mstrPath = Left$(strFullPath, intPos)
End Sub

Public Function item(ByVal lngIndex As Long) As ClsVbModule
 If lngIndex > count Then Err.Raise ERRBASE + 3, "ClsVbProject.item", "Item " & lngIndex & " not found in this collection."
 Set item = mobjVbModule(lngIndex - 1)
End Function

Public Function maxComplexity() As Long
 maxComplexity = mlngMaxComplexity
End Function

Public Function maxLinesOfCode() As Long
 maxLinesOfCode = mlngMaxLinesOfCode
End Function

Public Function maxNumberOfParameters() As Byte
 maxNumberOfParameters = mbytMaxNumberOfParameters
End Function

Private Function modulePathOf(ByVal strLine As String) As String
 Dim strResult As String
 Dim intPos As Integer
 strLine = Trim$(strLine)
 If UCase$(Left$(strLine, 5)) = "FORM=" Then
   strResult = Mid$(strLine, 6)
 ElseIf UCase$(Left$(strLine, 6)) = "CLASS=" Then
   strResult = Mid$(strLine, 7)
 ElseIf UCase$(Left$(strLine, 7)) = "MODULE=" Then
   strResult = Mid$(strLine, 8)
 ElseIf UCase$(Left$(strLine, 9)) = "DESIGNER=" Then
   strResult = Mid$(strLine, 10)
 Else
   strResult = ""
 End If
 If Len(strResult) > 0 Then
   intPos = InStr(1, strResult, ";", vbTextCompare)
   If intPos > 0 Then strResult = Mid$(strResult, intPos + 1)
   If InStr(1, strResult, "\", vbTextCompare) = 0 Then strResult = mstrPath & Trim$(strResult)
 End If
 modulePathOf = Trim$(strResult)
End Function

Public Function name() As String
 name = mstrName
End Function

Private Function nameOf(ByVal strPath As String) As String
 Dim intPos As Integer
 Dim intLastPos As Integer
 Dim strResult As String
 strPath = Dir$(strPath)
 intLastPos = Len(strPath)
 intPos = InStr(1, strPath, ".", vbTextCompare)
 While intPos > 0
      intLastPos = intPos
      intPos = InStr(intPos + 1, strPath, ".", vbTextCompare)
 Wend
 strResult = Left$(strPath, intLastPos - 1)
 nameOf = strResult
End Function

Private Sub parse(ByRef strFile As String)
 Dim strPath As String
 With New ClsTextFile
     .construct strFile, True
     strPath = modulePathOf(.firstLine)
     While Not .endReached
          If Len(strPath) > 0 Then add strPath
          strPath = modulePathOf(.nextLine)
     Wend
 End With
End Sub
